
=pod

Module O_D.pm 

A component of the chkr group of programs for monitoring applications, databases, networks, 
all types of servers, and more. By Nova Software, Inc. 

Copyright  by Nova Software, Inc. 2018  All rights reserved.  http://www.nova-sw.com

=cut




package O_D ;

our $VERSION = 0.180512;

use strict; 
use warnings; 

use O_B 0.170824; 
use O_M 0.170824;
use O_U 0.170824;

my $izD   = q1B; 
my $koD = qjB;
my $muD = kgB;
my $eiD = w1B();
my $baD = riB();
my $ksD = bhB();
my $l1D = xhB();
my $vaD = lhB;
my $aoD = liB;
my $jbD = nvB;
my $saD = ycB;
my $o2D = vjB;
my $axD = cpB;
my $arD = etB; 
my $ezD = odB();
my $quD = rmB;
my $pfD = xtB; 
my $tnD = (tuB)[0];
my $fyD = (irB)[0];
my $ogD = owB;
my $fpD = ldB;
my $umD = tsB;
my $akD = a1B;
my $ouD = fcB;
my $tgD = veB; 
my $vyD = emB;
my $bsD = s1B; 
my $cxD = taB;
my $oiD = zrB;
my $hbD = gvB;
my $ebD = ajB;
my $ocD = uwB;
my $maD = wcB;
my $zbD = w1B().xhB().lhB.xhB(); 
my $jcD = vsB;
my $lyD = 'self.cfg';

sub amD {
qq|
___________________________QUICK START INSTRUCTIONS____________________________

Start $baD the first time with the following command line in the base 
directory, 

$eiD

into which the program was installed: 

$baD cfg$l1D$lyD

The program starts checking its own host with default settings using the above 
cfg file created during installation at:

$zbD$lyD  

Copy this file to a new name and add other targets you wish to monitor using
the same syntax.  Use any plain text editor. (E.g. Notepad on Windows or Vi 
on linux. *Do Not Use* MSWord or similar word processors.)  

Stop the program with the command 

stopchkr

Allow a minute or so for the program to finish, then restart it with your cfg 
file with the command

$baD full_path_and_new_cfg_file_name

to begin checking the targets you have configured.  Review their status in the 
default status report file:   

$eiD$l1D$jbD$l1D$baD\_(new_cfg_file_name)_status.$saD 

This file is updated every minute by default.  Related information is in the 
default log file at:

$eiD$l1D$o2D$l1D$baD\_(new_cfg_file_name).log 

The above steps can also be done conveniently thru the User Web Interface (UWI)
menus if it was started during installation.  If not it can be started with 
the command 

startuwi

in the base directory.  Open a browser window to the URL given at startup. 

At first startup the program runs with the free, default-licensed, number of 
targets of $maD.  Purchase a subscription at 

www.appchkr.com

to license a greater number of targets.  Activate that subscription in the 
program with the -activate command line option.  


_________________________________TO LEARN MORE_________________________________

including how to change the default status and logfile names and locations 
and how to configure email and text alerting, type

$baD -basic

for basic configuration instructions or 

$baD -cfg

for complete information on configuration. 

To see the description of this program, including information on 
running multiple instances from one installtion, and for making
dynamic configuration updates, type 

$baD -desc

For the form of the run and stop commands type

$baD -run  

    or 

$baD -stop

and for all the available documentation options type 

$baD -options
|;
    
}

sub xeD {
    
    my $haD = $l1D.'somedir'.$l1D.'yourconfigfile.cfg';
qq|
_______________STARTING AND STOPPING USING THE COMMAND LINE____________________

On MS Windows open a command prompt window (DOS box).  
On Linux open a terminal shell session (TTY). 
On either change (cd) to the base (install) directory of the program. 

TO START and RUN: Type at the command prompt: 
  
$baD <config_file_pathname>

in which  <config_file_pathname> = $haD  

This cfg file must not already be in use by another running instance of the 
program. 

The program prints useful startup information and then disconnects to begin 
checking targets silently in the background.  Open the status report to 
monitor the current status of checking. 

On MSWindows a command prompt window can be opened from the Start menu, 
for instance, by entering \'cmd\' in the RUN... dialog box, or from the 
Windows System folder on the programs list in Windows10.    

The program can also be started from the \'Running...\' menu in the user
web interface. 

Further information on starting and stopping is given in the knowledge base,
-kb command line option.

_______________________________________

TO STOP A RUNNING INSTANCE: 

In the base directory, on either type of system, type at the command prompt: 

stopchkrs 

This command creates an orderly shutdown and may take a little time to 
complete.  

The program can also be stopped from the \'Running...\' menu in the user
web interface. 

See the knowledge base for additional information on, and methods 
for, stopping the program.  
|;
        
}


sub a3D {
    my $wrD = shift; 
qq|
$baD, r. $wrD: A member of the Appchkr family of versatile 
checking, alerting and reporting programs for applications, 
databases, networks, servers, and more.  
Copyright  by Nova Software, Inc. 2018.   www.nova-sw.com 
|;
}


sub qpD {
        
qq|
_____________________________COMMAND LINE OPTIONS______________________________

$baD -option_name    [second_parameter_if_required_by_the_option]

NOTES: No space between the - and the option name!  
       Some options require one or more additional parameters to be entered, 
       separated by one or more spaces from the name and each other.   
       Most options accept partial names, often only the first charcter.  
       Option names are not case sensitive.  
      
    -quick      Quick start information

    -about      Appchkr type, release number, subscription level, etc.    
    -activate   Activate a registered subscription for more targets 
    -advanced   Information on advanced features
    -all        All documentation on the program
    -auto       Enable or disable automatic subscription level changes. 
    -auth       Add web interface login credentials at the prompt.
    -auth  d user:passwd  Delete the given web interface login account
    -basic      Basic, simple configuration documentation
    -cfg        Complete documentation on configuring the program
    -cfg  cfg_section_type  
                cfg keys information for that section type. (r, s, or t)
    -deactivate Undo an activation WITHOUT ENDING THE SUBSCRIPTION.
    -desc       a detailed description of the program\'s operation
    -delsec     Delete a security alert. 
    -encipher   Encipher a password string of $umD or fewer 
                printable characters.  Enter the password at the prompt. 
                The enciphered result will be longer than the 
                original password. Be certain to copy all output 
                when transferring the result to a cfg file.  

    -findkey  partial_or_full_cfg_key_name  
                Find the descriptions for all the cfg keys matching
                the character string given (e.g. enter 'mail' to list 
                all keys containing 'mail' in their name, or 'add' to 
                list those containing that string.)  $umD characters maximum.

    -kb         Knowledge Base (FAQ).  Further details and cautions about the 
                program\'s operation, and about reports, alerts, and other topics.
    -listkeys   List all configuration keys alphabetically by section and name. 
    -options    This list of the command line options
    -protocols  List of the pre-configured protocol names 
    -run        How to run and stop this program
    -slfacility Common syslog facility designations
    -stop       How to run and stop this program
    -texting    How to receive text message (SMS) alerts using email addresses
    -uwi        How to start and stop the User Web Interface (UWI) server  
    
    
    These options can be run whether any other instances of the program in 
    this installation are running in checking mode, with the exception of  
    -deactivate:  It can only be run when all program instances are stopped.  
    
    The -activate option will switch running instances from free to subscribed 
    operation with a larger number of licensed targets.  
    
    The -auto option will switch the running instances\'s automatic 
    subscription upgrade-downgrade action. 
    
    The -delsec option stops the active security alert from being displayed at 
    startup. 
    
    The remaining options have no effect on running instances.  
    
|;




}    


sub auD {
qq|
Download:  http://www.appchkr.com/download-chkr.html
Subscribe: https://www.appchkr.com/secure/purchase-chkr.html
Subscription details:  http://www.appchkr.com/subscription-pricing.html
|;    
}

sub daD {
qq|
Deactivate an existing subscription activation in this installation at 

$ksD:$eiD

NOTE: DEACTIVATION DOES NOT CANCEL THE SUBSCRIPTION! 

The subscription is removed from this installation for reactivation elsewhere.  
This installation will drop back to the free quantity of allowed targets.  
The subscription continues in force until cancelled online at www.appchkr.com.  
Canceling a subscription there first automatically deactivates it. 

|}

my $hmD = uuB;
my $snD = cjB;
my $dhD = peB;


sub xnD {
no warnings;  
qq|
_________________________________KNOWLEDGE BASE________________________________

KB____________________ STARTING AND STOPPING

  Use the following commands from the command line in the program\'s base 
  (installation) directory.
   
- The preferred Appchkr stop command (see the option -stop) , 

  stopchkrs 
  
  creates an orderly shutdown.  It may take a little while to complete. 
  
  To stop running instances instantly use the command 
  
  killchkrs
  
  Either of these two commands stops all running instances and can be used
  to stop one or many instances.  
  
  To stop just a single instance when several are running use the command
  
  stopchkr cfg_file_base_name
  
  in which cfg_file_base_name is just the basename portion of the cfg file name 
  used to start that instance.  Use just the base filename, without any path 
  or extension part of the name.  
  
  To instantly shutdown a single running instance when several are running use 
  
  kill pid\# 
  
  in which pid\# is the pid number of the instance to be stopped.  This number 
  is given at startup, in the reports, and throughout the log.  
  
  Using the above kill* commands to stop the program abruptly should only be 
  done in an emergency.  Too frequent use increases the chance of subsequent 
  startup issues.

- Start the user web interface (UWI) program with the command

  startuwi
  
  and stop it with 
  
  stopuwi
  
  The UWI uses very few system resources when idle, so it is convenient to 
  just leave it running whenever its host is running to allow instant remote 
  access via a web browser. 

- Appchkr instances can be started and stopped with any mixture of methods. In 
  other words an instance started from the command line can be stopped in the
  UWI and vice versa. 

- The message 'END....' received when the program is started is normal and not 
  a cause for concern.  It indicates the conclusion of the first stage of 
  startup.   

- The User Web Interface (UWI web server) for managing the program remotely 
  uses port $hmD to connect, by default.  If this port is already in 
  use on the host machine the UWI server will fail to start.  To fix this 
  problem add an unused port on that machine to the start command thus:

  startuwi port_number
  
  Port numbers which are in use can be found with the command:
  
  netstat -a -n
  
  on either type of system.  Choose a port number not on this list and lying
  between $snD and $dhD  to avoid conflicts.  This port number 
  is then used in the browser address bar rather than $hmD to connect 
  to the server.  The current port number for connecting to the UWI when it is 
  running is always given in the file \'uwi_port_number.txt\' in the base 
  directory as a memory aid.  This file is never deleted.  If the UWI is not 
  running the file gives the last port number used to run it.   

- Instances of an Appchkr program can be started from the command line or 
  from the \'Running...\' menu of the web interface and stopped by the other 
  method.  In other words it makes no difference how an Appchkr instance was
  started when deciding to stop it -- any available method will work, 
  independently of the method used to start it. 

- The program is designed to run continuously rather than in start-stop mode. 
  If you wish, for instance, to check targets only during the daytime it is 
  preferable to use the dynamic cfg capability to switch between \'daytime\' 
  and \'nighttime\' cfg files to turn checking on and off rather than turning 
  the program itself on and off.  This way there will be only one uptime file 
  which will cover the operation continuously.  However, if you do choose 
  start-stop mode in such a situation be aware that a new uptime file will be 
  started each time the program starts. The older ones beyond a certain age
  are deleted by default.  Manage this behavior with the \'UpTimeFilesAge\' 
  cfg key.  The files are csv-formatted (tab separated) so that they can be 
  combined or merged by using common spreadsheet programs. 

  
KB____________________ WINDOWS \'STARTUP...\' 

- On Windows a \'startup...txt\' file is written in the base directory on each
  startup of any instance of the program.  This file gives the locations of 
  the report files and log since these can not be shown in the initial startup
  message on Windows.  On linux these file paths are included in the startup 
  message response at the command line, so no separate \'startup...\' file is 
  created.
  
- Note that there is only one \'startup...\' file name so starting another
  instance of the program with a different cfg file will overwrite any 
  previous copy of the startup file.  Rename the file or move or copy it 
  elsewhere to save it.  

- The program normally runs in daemon mode on MSWindows with the identity
  of the user who started it, without any attached command window.  It is not 
  a \'Service\' as defined and managed by Windows.  If the user logs off 
  Windows after starting the program Windows stops it.  Use the \'Lock Screen\'
  or \'Switch User\' capability of Windows instead of logging off after 
  starting the program to keep it running while preventing unauthorized users 
  from accessing the account.  Access these two commands with the ctrl+alt+del 
  key combination on Windows.


KB____________________ OPERATIONAL HINTS

- Run the program on a machine of its own, not shared with any other apps,
  so that there are no inadvertent reboots that mistakenly shutdown the 
  checking. 

- Host the program on a machine with a wired (ethernet) network connection,
  rather than WiFi or Bluetooth.  Radio connections are less reliable than 
  wired ones, and can distort the checking results. 
  
- Use the default cfg file, log and report locations for most convenient use
  of the UWI (user web interface).   For security of the host machine and the 
  network the UWI is limited to accessing files only within it\'s own 
  directory space.  It cannot access other areas on the machine although 
  $baD itself can do so.  Use this latter capability when operating the 
  program primarily from the commandline.

- Target sections can be conviently named in three parts thus: 
  a1 some-host http
  in which a1 are the leading charcters to control checking order, 
  some-host is the target machine name, and http is the protocol or port
  number being checked in this target section.  Such a scheme helps to 
  make log entries and reports most immediately understandable and helps
  to avoid configuration errors.  

- Keep target names as short as possible consistent with uniqueness and 
  clarity.  Add additional information you wish to preserve about the target 
  following the \']\' which ends the section name, on the same line, or with 
  the comment capability, in preference to filling out the target name.

- Use the watchdog feature for high reliability with a remote monitoring
  system such as another installation of the free version of Appchkr checking
  the watchdog.  Have each system monitor and send a text alert on the the 
  other\'s watchdog for the highest possible overall level of reliability.

- Turn off email and text alerts on an individual target by setting 
  its criticality = low, or by specifying an empty maillist for it thus:
  
  MailList = 
  
  Syslog alerts, if provided and enabled, and alerts on all other targets 
  continue to be sent. 

- Use the heatbeat feature -- a missing heartbeat alerts you to an alerting, 
  configuration, mail server, network, or checker host machine issue that
  might otherwise go unnoticed. 

- When email alerting is used enable the AdminMailList, if provided, and 
  watch for the startup email at those addresses to confirm that alerting is 
  working.  If dynamic reconfiguration is in effect each reconfig also sends 
  a confirming alert to that list.  Lack of this alert when email alerting was 
  working earlier could indicate an alerting configuration problem with the 
  reconfig.  In a similar fashion those on the AdminMailList receive all the 
  CFG ERR alerts so that (re-)configuration errors affecting the checking can 
  be corrected before they do damage. 

- For highest alerting reliability use both email, and syslog alerting, if 
  available in your Appchkr type. 

- Use the \'nochecking\' feature, rather than commenting out or deleting
  target sections, to temporarily stop checking on a target.  This method
  is properly accounted for in the reports, whereas the other two are not.

- Higher target count systems work best by using multiple cfg files and 
  instances to reach those levels.  Too many targets in one instance lengthens 
  the checking loop period and decreases response time.   Split the list by 
  protocol, subnet, hostname range, or any other convenient grouping. 

- Use multiple checker installations at different points in the network, 
  checking the same targets, to pinpoint immediately a network issue vs. an 
  application one for critical targets.  If all checkers show the same failure 
  at the same time for a target it\'s an application or host machine issue.  
  Otherwise it\'s a network problem.  The checker(s) showing the failure 
  indicates the likely network path(s) at fault.  Appchkrs\' economical 
  pricing along with the unlimited availability of the free version make this 
  technique feasible without breaking the budget.  This technique is also 
  useful for troubleshooting a problem target since a cfg file with just one 
  target can be created and distributed to multiple checkers quickly and easily,
  especially when the UWIs (user web interfaces) are used. 

KB____________________ INSTALL, UPDATE, ROLLBACK AND UNINSTALL

- Install_chkr, update_chkr, rollback_chkr and uninstall_chkr must all be run 
  from within the Appchkr\'s base or installation directory, 
  $eiD
  not from a different directory with the Appchkr base directory added to the 
  path.  While some portion of these scripts may appear to function correctly 
  in such a case they are not currently intended nor tested for such operation.  
  Other portions may fail silently leading to incorrect results.  Such a mode 
  of operation for these functions is not currently supported. 

- The presence of a software update file ready to be installed is noted in the
  log, on reports, by an alert if those are enabled and in the UWI page.   
  Simply start or restart a $baD instance from the commandline or restart 
  the UWI.  You will be prompted to enable the update which then takes only a 
  few seconds.  All running instances are stopped as part of the update and 
  can be restarted under the new release immediately following the update. 
 
- Subscribers should allow the automatic process to manage software updates to 
  the program.  It should rarely or never be necessary for a subscriber to 
  download an update from the website.  You are prompted to OK installation of 
  each automatically loaded update whenever $baD or the UWI is started 
  from the command line.  
  
- Users of the free version must download updates manually from time-to-time 
  to keep their installation operational: Each release has a time limit when
  running in free mode.  The update will run with the normal prompts just as
  for the subscription version when $baD or the UWI is started from the 
  commandline.  Find the current download at 
  http://www.appchkr.com/download-chkr.html
  Support for the free version is provided via the user community forum and
  other means noted on the website support pag. 
  
- If program files in an installation become damaged they can be repaired 
  from the chkr_update_...zip file of the same version.  This file may be 
  found in the \'bak\' directory or at the Appchkr download page on the web,
  http://www.appchkr.com/dowload-chkr.html.
  Put a copy of this zip in the base directory and run update_chkr.  
  
- Some program damage may not be fixed by updating.  Uninstalling and 
  reinstalling may be required.  User data is preserved thru this process.  
  Credentials must be reenciphered, and any subscription activated anew, just 
  as for a new install.  
  
- Always uninstall before reinstalling.  Installing again over an existing 
  installation is normally not possible and is not supported. 
  
- A rollback capability is provided should serious problems arise after a 
  software update.  Rollback uses the existing chkr_update_...zip file from the 
  *prior* update, normally found in the \'bak\' directory, so by default rolls 
  back to the previous release that was running just before the latest update.  
  An earlier release number can also be provided as a command line input, for 
  user convenience.  Place the chkr_update_...zip file for that release in the 
  base directory and run \'rollback_chkr  that_release_number\'.  However 
  rollback across multiple releases may or may not succeed and is not 
  guarenteed.  Similarly, rolling back across one or more ignored intervening 
  releases may or may not succeed.  Only rollback to the immediately prior 
  release is supported. 

- Rollback does not automatically \'ignore\' the release from which the 
  rollback occured.  Subscribers will receive that update file again via the 
  automatic process and be asked to install it.  Simply decline and select the 
  \'ignore_update\' option to continue to skip that update.  

- The \'ignore_update\' capability applies only to one release.  When a new
  release becomes available it must be installed or \'ignored\' again until 
  the next one, and so.   The \'ignore_update\' feature is intended only for 
  unusual circumstances.  It\'s use should rarely be necessary and is 
  discouraged in ordinary circumstances. 

- If an update has been \'ignored\', and later it is decided that it should be 
  installed, run the \'update_chkr\' script with the word \'force\' added on 
  the commandline as the first parameter.  This command will remove the 
  \'ignored\' condition and allow the update to complete normally.  You will 
  then be prompted to OK the update, as usual.  

- All software updates are cummulative and include all prior updates.  If one 
  or more updates have been skipped with the \'ignore_update\' feature only 
  the latest update need be run to bring the installation up to the current  
  release level.  It is not necessary to run any of the intermediate updates. 

- Uninstall_chkr can only be run after installation has been completed.  To 
  abort an installation that has only been unzipped run \'install_chkr\' to 
  complete the installation and then run \'uninstall_chkr\'.  This takes only 
  a few seconds more.  Alternatively delete the unzipped files and directories 
  manually without running install_chkr.  


KB____________________ LOCAL LOG FILE

- Always check the log at startup for mis-configuration issues, particularly 
  those that might prevent receiving alerts.  Such problems are always logged 
  to the local log.  

- Consult the log file whenever questions arise about runtime behavior of the 
  program.  All actions that the program takes, the results, and their 
  explanations are logged there to provide answers to such questions.   The 
  location of the log file is given in the startup message and all alerts, and
  can be changed from the default in the configuration file.


KB____________________ CONFIGURATION

- Use the -listkeys (-l) option at any time to find which configuration keys 
  exist and the correct spelling of their names for entering into a cfg file.  
  
- Use the -findkeys (-f) option at any time to get the detailed description of 
  the function of any configuration key. 

- The full configuration filepathname must contain only the characters 

  $aoD. 

  The config filename must not begin with a '-' (hyphen).


KB____________________ SUBSCRIPTIONS

- Higher target count limits than the free default value are enabled thru
  a subscription license created on the program\'s website at www.appchkr.com.  
  The subscription then must be activated with the program\'s -activate option. 
  Further detail may be found at 
  http://www.appchkr.com/subscription_pricing.html

- Hostname of the machine on which the program is activated is a key part
  of subcription activation.   Reactivate promptly if the hostname changes.  

- The \'auto\' commandline option enables and disables automatic subscription
  level changes for all instances (i.e. all cfg files) in an installation.   
  That single setting is used by, and affects all, instances run from that 
  installation. 
  
- Enabling auto downgrade will downgrade a subscription level immediately at 
  startup if the configured target count of the first instance to be started 
  is below a subscription level change.  If auto upgrade is also enabled the 
  level will be raised again by adding targets beyond a level change or 
  starting another instance with the same result.  However, it is possible to
  hit a daily activity limit imposed by your financial account issuer if the 
  level is changed too often, preventing further level changes.  For this 
  reason it is advisable to leave downgrade disabled during initial trials 
  until a stable set of cfg files and targets is achieved.  

- Only one subscription is needed for one installation, even if multiple 
  instances are run in that installation.  All running instances of the 
  program divide the licensed target count among themselves automatically, 
  each taking its portion until no more is needed or none is left.  Make sure
  that your subscription level is greater than the sum of the targets in all
  the instances to avoid hitting a licensing limit on checking, leaving some
  targets unchecked. 


KB____________________ EMAIL CONFIGURATION

- The password for the mailfrom account is normally needed for your email 
  server to be able to send email and text msgs to external email accounts 
  on remote mail servers.  If mailing to internal accounts only on the 
  same server, i.e. within the same organization, it is normally not needed.  
  Check with your system administrator for the requirement within your 
  organization.  

- Two email ports, 25 and 587, are the standard port assignments defined  
  worldwide for sending email.  If one of these fails the alerting process 
  tries the other from time-to-time.  A record is kept of which port is 
  generally succesful and that one used most often.  To disable this searching 
  process and use only a single one of these two ports enter that value in the 
  MailServerPorts key, if provided, and likewise to use any non-standard port 
  or ports.

- Logging in to the 'mailfrom' account at the configured mailserver is limited 
  to two failed attempts in order to avoid locking out the account with too 
  many tries.  This limit is cleared when an updated cfg file is read: two 
  more tries are made if there is a mailfrompswd configured.  No attempt is 
  made to determine if the mailfrompswd has changed from that of the previous 
  file, if any.  The two-try limit applies on each new file containing a valid 
  MailFromPswd, independently of any earlier configuration in the session.  


KB____________________ DISCOVERY -- (networkchkr and serverchkr ) 

- Discovery and checking of all active targets over a specified range of IP 
  addresses, for a particular port or protocol, in these Appchkr types,
  can be configured if there is an activated subscription.  Review the 
  description of the \'HostRange\' key under \'Targets\' for details. 

- Discovery runs during the program startup configuration phase, before 
  logging and checking begin.  If long \'DiscoverySlowdown\' delays and large 
  discovery hostranges are used, checking on startup will be noticeably 
  delayed until discovery completes.  Discovery progress can be followed during 
  this time in the discovery log whose location is printed at startup. 


KB____________________ USE IP (on selected Appchkr types) 

- By default the program uses IP addresses for checking, automatically 
  converting any host name into a numeric IP address.  This setting may be 
  changed at the global or individual target level.  See the description of 
  the \'UseIP\' configuration key.  

- When the \'UseIP\' feature is in effect failing targets are then checked 
  with their FQDN (hostname), if available, before reporting any failure.  
  The details of this attempt are logged with the connect/no-connect entry 
  in the log. 
  

KB____________________ ENCIPHERING PASSWORDS

- The password for the email account used to send email and text alerts may 
  be enciphered from the command line using the -encipher option on the 
  machine hosting the program.  Enciphering can only be done from the 
  command line: Remote enciphering via the web interface is not provided for 
  security reasons.
  
- Copying and pasting an enciphered password can be quicker and more reliable
  than trying to correctly remember and retype the characters elsewhere.  A 
  convenient way to copy and paste an enciphered password on Windows is to 
  copy it with the MARK function in the command prompt window in which it is
  first created, then paste it into Notepad and save it as a file on that 
  host.  That file can then be shared across the network or mailed to a 
  remote system on which a cfg file is being created.  A similar process
  applies to enciphering passwords for access to the User Web Interface. 


KB____________________ NO CHECKING

- The word \' $ebD \' (case insensitive) following a target section 
  name on the same line turns off checking for that target section. Any 
  following text on that line is ignored and may be used to indicate the 
  reason the target is not being checked, thus
  
  [some target name] $ebD   network card failed, new one on order
  
  Thus the configuration of that target section in the cfg file can be quickly 
  and easily preserved thru a temporary outage of a target while preventing 
  useless alerts.  No need to delete it nor comment it out.  In addition all 
  reporting takes proper account of \'$ebD\' periods in calculations, 
  unlike deleting or commenting out a target section.  Alerting slowdown 
  starts over after any \'$ebD\' period. Primarily useful if dynamic 
  configuration is in effect.  

  CAUTION: CHANGES IN THE UP/DOWN STATE OF TARGET\S ARE NOT DETECTED WHILE 
  CHECKING IS DISABLED. REPORT\S MAKE NO ASSUMPTION ABOUT A TARGET\'S STATE 
  DURING ANY \'$ebD\' PERIOD, BUT SIMPLY CLASSIFY IT AS \'ajB\'.
  
- The word \' StopAllChecking\' (case insensitive) following the Setup section 
  name turns off checking for ALL TARGET\S, GLOBALLY.  Any additional text on 
  the [Setup] section name line is ignored and may be used to note the reason 
  for no checking, thus 
  
  [Setup] stopallchecking   downtime for network reconfiguration.
  
  Intended only for stopping checking on temporary, exceptional conditions 
  such as a major outage of the network while allowing this system to continue 
  to run and preserve reporting statistics.  Only checking of targets is 
  affected by this value:  Looping, logging and reporting continue while 
  checking is off.  A periodic reminder alert is sent while global 
  \'$ebD\' is in effect.  Although this alert may not be effective 
  during a major network outage, it will provide a reminder once network 
  operation is restored that checking is still off.  There is no slowdown 
  on this alert.   
    
  EXTREME CAUTION IS RECOMMENDED IN THE USE OF THIS GLOBAL SETTING:  
  BE CAREFUL NOT TO DISABLE ALL CHECKING AND LEAVE THE SYSTEM RUNNING, 
  FORGETTING THAT ALL CHECKING IS DISABLED. :-( 
  
  Individual targets may have checking forced during such a global 
  \'STOPALLCHECKING\'condition by placing the word \'ALWAYSCHECK\' (case 
  insensitive) following the section name brackets of the target and before 
  any other text on the line, thus:
  
  [My_supercritical_target] alwayscheck    *NEVER* ignore this one!
    
  This phrase has no effect at any other time. 


KB____________________ DYNAMIC CONFIGURATION

- Use the dynamic configuration capability to change the lists of alert 
  receipients when the people on duty change.  (For example by shift, weekly, 
  or day/night.) Similarly, the list of targets checked can easily be varied
  between, for example, day and night or weekdays and weekends, by making  
  two copies of the cfg file, one for each situation. The active cfg file 
  is then replaced by the other while running to switch to the alternate
  configuration at the time required.  This switchover can easily be automated
  with a short simple batch or shell script and crontab (linux) or task 
  scheduler (Windows).  Just copy the relevant file from a holding directory 
  to the active location at the time desired.  A sample file showing how to do 
  this is included in the distribution.  

- When dynamic configuration is in effect changing the existing name of a 
  target results in deleting data for the old name and starting fresh with
  the new name, as though it were a newly entered target.  Up and downtimes,
  alerting slowdowns, and so on start again from zero with the revised name. 
  
- Once successfully started in dynamic configuration mode the program continues 
  to function with its existing configuration if later it can\'t find or is 
  unable to read the configuration file.  An administrative alert is sent on 
  each such failure (e.g. each loop) if alerting is enabled.  There is no 
  slowdown on this alert.    

- Dynamic reconfiguration occurs only when there is an actual configurable 
  difference between the newer cfg file and the previous one.  Non-functional 
  changes such as adding or deleting a cfg key with the default value, adding, 
  changing, or removing comment lines and blank lines, and so on, cause only a 
  notice to that effect in the log preceeded by a copy of the revised file, 
  but no revised internal cfg listing in the log.  This latter only shows in 
  the log upon a functional configuration change.  If administrative alerts 
  are in effect this distinction is indicated in the configuration alerts.  In
  particular a list of the first few changed sections, keys, and values is 
  included in the reconfiguration alert.
  
- Any time the cfg file is changed (with dynamic configuration in effect) the 
  updated cfg file appears in the log for reference.  A change made only in a 
  comment, for instance, will thus cause the file appear in the log at the end 
  of the loop during which the change was made. 

- When a dynamic configuration change is made the functional differences (if 
  any) are listed in the log and in email cfg change alerts.   Check this 
  difference information on each dynamic update to avoid unintended changes
  due to typos or other errors. 


KB____________________ REPORTS

- The uptime report is based on time differences between events, so requires 
  multiple polls (loops) to accumulate significant results.  The status report 
  displays only the current state of all targets at the end of each loop, 
  without regard for any prior state, so is a snapshot that can change 
  arbitrarily from one loop to the next. 

- When reports are viewed using the User Web Interface they are updated every 
  minute so are always current.  Viewing them in an auto-updating editor or
  program such as 'tail' will also keep them current with the latest copy put
  out by the checker program.   

- Although normally the status file is configured to update on every loop, not 
  all targets may be checked on each loop, depending on their configurations.  
  A target\'s elapsed time in a particular state, as shown in the status file,  
  only gets updated when the target actually gets checked (polled), not 
  necessarily on each loop.  The time of the last check is given at the end of 
  the status line for each target.  

- Report lines are ordered by criticality level first, then alphabetically 
  within that criticality level.  In addition the status report lists \'down\' 
  targets first, then \'nochecking\' targets, then \'up\' targets before 
  applying the criticality rule.  

- The report files are tab-separated and can be loaded into a spreadsheet  
  program that can read such files, for convenient re-sorting, filtering, 
  graphing, and other data manipulation.  Change the extension on a report 
  file from $saD to .csv when you export it to allow it to be to be 
  automatically recognized and loaded by common spreadsheet programs.  
  Alternatively it can be opened with its existing extension by the \'Open\' 
  command from within the spreadsheet program.


KB____________________ REPORT GROUPS -- networkchkr and serverchkr types only 

- The \'reportgroups\' cfg parameter provides reporting capability for groups 
  of target systems, over and above the individual reporting for each target.  
  Groups are entirely defined by the users based on their own criteria. Groups 
  could be chosen for a longitudinal association, with the targets operating 
  in series on some set of data, or for parallel operation in which the 
  targets all perform the same function with the data split between them, or 
  for any other reason.  For example, all database targets could be configured 
  with one group name so as to provide a report line summarizing the status of 
  all databases as a group.  In addition a DB, for example, may also be the 
  backend for a chain of servers implementing some particular function such as 
  a website.  A different group can be defined for that set of servers so that 
  the status and uptime of that entire website function can be summarized in 
  one line in reports.  The DB server target for the website can also be listed 
  as a member of the DB group, i.e. it can participate in both groups 
  simultaneously. 
  
- Targets with ReportGroups do not all need to have group membership in 
  common.  Target 1 might be in groups A,B, C while target 2 is a member of 
  groups B and C, target 3 is a member of group A only, and target 4 has no
  group membership at all. 

- Members of the same report group should all have the same checking interval 
  or checking frequency value, and be started simultaneously, to provide the 
  most meaningful results.  

- There is no arbitrary programmed limit to the number of groups defined in a 
  cfg file, or to the number of targets in a group.  System loading and 
  performance degradation may create a practical limit.  
  
- ReportGroups may not be used with targets set for AlertOnUp (i.e. 
  AlertDirection = UP).  Any defined are ignored and a CFG ERR alert sent if 
  alerting is enabled.   


KB____________________ UPTIME REPORT 

- The uptime report may be configured to cover the entire period since startup 
  of the program or a defined interval.  When the report is restarted, either at
  program startup or expiration of the interval, any previous copy is saved in 
  the same directory with the date and time added to the name.  These are saved 
  for 40 days by default.  Change this value in the \'$koD\' section of the 
  cfg file. 
  
- In the uptime report any \'$ebD\' time of a target since program 
  startup is deducted before calculating percent up and down times:  The 
  program makes no assumption about the state of the target during any period 
  in which checking is disabled.  
  
- Elapsed times for each target in the uptime report are calculated and 
  reported based on the times the target is actually polled in the checking 
  loops, not the time of the report.   Targets checked later in the loop will 
  show slightly shorter elapsed times than those earlier in the loop since the 
  loop takes a finite time to poll all targets.  Furthermore this time 
  difference can vary from loop to loop, based on the number of targets up or 
  down and other events.  As a consequence a system with one up and one down 
  target, for instance, will show system averages slightly different from 
  50% - 50%, by the amount of this difference in elapsed times of the two 
  targets.  A similar result holds for larger systems. 

- In the uptime report targets which have \'$ebD\' in effect will not 
  show a change in their percentage up and down values from one update to the 
  next.  They continue to exhibit the values in effect at the time that 
  nochecking began.  Targets which are disabled at startup show 0% for both 
  values until enabled.  The total elapsed time of checking since startup is shown 
  for each target along with an indication of the amount of \'$ebD\' 
  time, if any.  Percentage up and down times reflect only the periods during 
  which checking is enabled.
  
- Use the \'nouptime\' cfg key in the $koD section to default uptime 
  reporting to off for most targets and override it only in a few target 
  sections to select those which need it.   This key is provided as a 
  configuration convenience for large systems to keep the report small and 
  free of unwanted detail.  Alternatively the \'uptimeupdate\' key in the 
  \'$koD\' section can be set to 0 to stop generation of the report 
  entirely.  This setting, however, cannot be overridden in the individual 
  target sections.  

- Reported percentage up and down values *do not* change in the loop in which 
  a change in a target\'s state occurs:  Recording the change of state of a 
  target occurs at the time that the poll occurs.  A positive time difference 
  for that state first occurs the next time the target is polled (assuming 
  that its state has not changed again,) which could be several loops later, 
  depending on configuration.  Thus the percentage up or down only changes on 
  some loop *after* that in which a state change occurs, and thereafter, until 
  the state changes again.  Use the status report to see state changes at the 
  time at which they occur.


KB____________________ PORT NUMBERS

- Valid port numbers lie in the range 1 to 65535 on all types of systems with 
  a standard installation.  On linux the numbers between 1 and 1023 are often
  reserved for system use where many of the most common system services are 
  located, and only for use by the root or admin account.  Many ports between 
  1024 and 4095 have also been registered with IANA for more specialized but 
  also fairly widely used static services so are also generally avoided for 
  individual needs.  Ports above 4095 to 32767 are less commonly taken and are 
  the best area in which to choose a port for an individual need.  Ports above 
  32767 are now designated by IANA for dynamic use and are best avoided.  Port
  number conventions prior to 2014 were more varied, especially on Windows, so 
  an older system may not conform to these conventions.  In addition one or 
  more of these conventions may be overridden on a customized system.  
   

KB____________________ GENERAL 

- Use the 'frequency' configuration key  to permit simple slowing down or
  speeding up of the checking rate of all targets uniformly.  Use the 'interval'
  key  to schedule checking of targets based on time only, without coupling
  to other target settings.  Refer to the configuration details ( -cfg option) 
  for specifics. 

- If the host url is missing or invalid in a target section that target is 
  treated as if it has checking disabled (nochecking)  The target is shown 
  as such in the reports.  These conditions are logged and alerted as 
  configuration errors.  

- For a very stable set of targets which rarely register outages use the 
  heartbeat feature to send periodic emails for assurance that checking is 
  still active.  It is on by default, being sent every midnight.  This 
  period is configurable in the $izD section. 
  
- A negative loop wait time shown in the log means that that loop took that 
  much longer than the minimum configured time.   No additional delay time is 
  inserted for negative wait times.   Delay of the amount shown is added to 
  the loop for positive loop wait times.  This algorithm insures that polling
  is never more frequent than desired.   
     
- Only those targets that are checked in a loop have their result logged.  
  Targets which are not eligible for checking in a particular loop do not 
  appear in the log for that loop.  All targets are checked on the first loop. 
  
- If a protocol from the internal named list is specified for a target, and a 
  port number is also specified, that port number overrides the default for 
  that protocol as given in the list.  Also applies to global defaulting.  

- Syslog messages are sent in an RFC3164 compatible format, which is
  <faciity_id priority>timestamp hostname appname[pid]: message  
  in which the message part is limited to 1024 bytes on one line. 

- The global default protocol to be checked is automatically selected by the 
  program based on the operating system on which it is running.  If this 
  default is used as-is it is simplest to run one instance checking only 
  targets running the same OS (e.g. Windows to Windows, linux to linux) and a 
  second instance for the opposite OS, if needed.  Otherwise the default will 
  have to be overridden manually with an entered protocol value for all 
  targets in the cfg file of the opposite type of OS.  Using separate 
  instances and cfg files makes possible configuring the entire set of 
  targets on the opposite OS type with one global cfg setting. 

- Use one or more of the following methost to check whether an Appchkr is still 
  running (e.g. if something has happened to the mailserver or its connection 
  that is preventing alerts and heartbeat messages from reaching you. ) 
  (1) Check that the time on the status report is the current time (if enabled), 
      and watch for it to update every minute (or at whatever update interval 
      is configured.)  Especially quick and easy to do from the web interface.  
  (2) Check the end of the log to see that it is updating.  (View menu in UWI.)    
  (3) On Windows: 
    (a) Use the tasklist command in a command window
    (b) Open task manager (ctrl+alt+del) to review the list of running processes.
  (4) On linux 
    (a) Use the ps -fe command at the command line or in a terminal window
    (b) Use 'top'.  


KB____________________ CAUTIONS

- $baD does not detect internal issues in target programs in which 
  a network connect response is given but internally the target is not 
  fully functioning, i.e. certain partial-failure situations.  Such 
  occurences are rare but may be detected by a program that makes a complete 
  protocol-specific probe (HTTP, FTP, SSH, SMTP, etc.).  

- If ssh is used as the checking protocol on Linux (the default) the 
  \'secure\' system log (/var/log/secure) may log each checking occurence as 
  an incomplete ssh login.  In such cases it may be desirable to modify or 
  eliminate such logging by the ssh daemon, or to periodically clear that log 
  to keep its growth under control during a long period of checking.  
  Alternatively set the default protocol in the $izD section to something 
  other than ssh.
  
- $baD cannot be reliably run on a computer which sleeps or hibernates 
  periodically, such as a laptop which is closed each night.  The sleep 
  period contributes to the calculation of uptime but no checking results
  are collected during that time, giving a misleading result. 

- It is best not to mix different AlertDirection values in a single cfg file
  on those Appchkr types with this feature.  The checking timeout must expire 
  on every target which is down before checking the next target, whereas most 
  targets which are up respond in a much shorter time.  Thus a configuration 
  of mostly down targets will normally take much longer to complete one loop 
  than a configuration with mostly up targets.  Run one instance of the 
  program for the normally up targets and another for those normally down, 
  which are configured to alert on up, in order to get the shortest latency 
  times on the normally-up targets.  Doing so also allows configuring the 
  AlertDirection key once, globablly, in each file, rather than 
  target-by-target. 


|; 

}



my $nuD = gcB -1;
my $zjD = acB;
sub xoD {
qq|
______________________________ ADVANCED FEATURES ______________________________

ADV____________________ PASSWORD ENCIPHERING

- Passwords must be enciphered by the program installation which will use 
  them. They are unique to that installed copy and cannot be migrated across 
  different installations of the program even on the same machine.  An 
  enciphered password will work for all program instances run in that 
  installation.  Software updates do not require reenciphering passwords:  
  Existing enciphered passwords will work unchanged when an installation is
  updated to a later release.

- The encipher option functions only from the command line.  It cannot be done 
  through the web interface, for security. 
  
  
ADV____________________ FILE PATHS

  It is possible to use relative paths in the cfg file for file paths such 
  as the logfile and the report files if there is good reason to do so.  The 
  program will take them as relative to the directory from which it was 
  started, normally its base directory.  Absolute paths are generally safer 
  and less ambiguous however, and should normally be used to place these files 
  anywhere else. 

- The program can be started from the command line from some other directory 
  than its base directory by adding the program\'s base directory to the 
  permanent PATH definition on your system and then opening a terminal session
  (Linux) or command window (MSWindows).  This addition is normally done thru 
  your home dir .bashrc file on Linux, or thru an Advanced setting within the 
  ControlPanel System category on MSWindows.  Any relative file paths in a cfg 
  file will still be taken as relative to program\'s base directory however.  
  Absolute paths are safer and less prone to later mistakes, however, and 
  should normally be used for all file paths.   

ADV____________________ RETRY CFG KEY
 
  Occasionally a target or the intervening network may have chronically or 
  intermittently slow response.  If it is desirable not to have failure 
  messages for such a situation a \'retry\' key  may be specified for any 
  target that shows such a problem.  If increasing the value of the 
  \'connecttimeout\' key is not sufficient then try this \'retry\' key.  It 
  specifies the number of retries to be attempted before declaring a failed 
  connection attempt, in the event that the first attempt fails.   Retrying 
  ends when a connection attempt succeeds or the configured limit on retries 
  is reached.  The latter case is treated the same as any other failed 
  connection attempt.  Success on attempt two or greater but below the limit 
  logs the usual success message and a warning about the retries.  Use this 
  feature sparingly: There is a small delay between retry attempts so use of 
  a non-zero retry value will delay checking on subsequent targets and 
  lengthen the overall loop time.  Targets that are actually down will use all 
  retries, further increasing the delay for subsequent targets, so small 
  values are advisable.  Allowed values for the \'retry\' key are the integers 
  between 0 and $nuD.  The default is 0.  There is no global retry key 
  in the \'Setup\' section.  Use it only on individual targets when absolutely 
  necessary if increasing \'ConnectTimeOut\' does not help.  On most 
  well-behaved systems no retry is needed.  This key only affects targets with 
  AlertDirection = DOWN.  It is ignored for those with AlertDirection = UP. 
  CAUTION: Sudden connect failures and then success on the following poll of a 
  target previously functioning normally can be indicative of network or host 
  system slowdown, congestion, or other such condition needing attention.  It 
  is advisable to NOT use this parameter to mask such a condition, but rather 
  to correct the underlying cause and restore flawless checking. 

  
ADV____________________ STARTING AND STOPPING

- Deleting a pid file of a running program stops it at the end of the current
  loop in an orderly fashion.  This is the normal shutdown process provided 
  via the program control files and via the web interface.  Any other methods, 
  particularly on MSWindows, may stop the program abruptly, possibly leaving 
  the program in an unsuitable state for the next startup.  We recommended 
  always using the provided means of shutdown, even though it may mean a short 
  wait for the shutdown to complete. 


ADV____________________ NO-DAEMON SESSIONS

- Both $baD itself and its user web interface (UWI) can be run in an open
  command prompt window (MSWin) or terminal session (all other OS\'s) rather
  than as daemon processes if necessary.  Enter $zjD as the first 
  command line parameter, before the cfg file pathname, when starting the 
  program.  The program runs as long as the command/terminal window remains 
  open.  Note that this parameter has no effect when using the command line 
  options, which always run in non-daemon mode.  On Windows the UWI (user web 
  interface) cannot be stopped from the command line in that window.  Either 
  kill it from another command window with taskkill, with the Windows task 
  manager, or by closing the command window.  The $baD program on any 
  system and the UWI on non-Windows systems can be killed in the normal way 
  in the window in which they were started or by closing the window. 


ADV____________________ LOGGING

- By default no log message is written when a target is not elegible for 
  checking on a particular loop.  This behavior can be dynamically overridden 
  at any time by placing an empty file named \'LOG_ALL_TARGETS\' in the 
  base directory 
  
  $eiD,
  
  the location into which you installed this program.  This will cause a log 
  entry for every valid target in the cfg file in every loop , including those 
  ineligible for checking in any particular loop.  The additional logging may 
  cause the log file to rotate substantially more often and slightly increase 
  the loop time.  Remove this file at any time to stop the additional logging.


ADV____________________ ALLOCATION OF LICENSE COUNT

- Allocation of subscription licenses to targets is by alphabetical order 
  by target names, not order in the cfg file.  This is the same order as
  that in which the targets are checked.  Thus the first targets to be  
  excluded, should the subscription level be too low, will be those that
  would be the last to be checked.  Note that targets with \'nochecking\' set
  count the same as any active target.  All targets in the cfg file are 
  listed in the log, including those which have no allocated license count,
  although these latter ones are not checked. 
  
- Allocation of the free default licenses to targets is by order in the cfg 
  file.  The first 10 are logged and checked.  Any remaining in the cfg file 
  are ignored and are neither logged nor checked.  Targets with \'nochecking\'
  set count the same as an active target. 
  

ADV____________________ MULTIPLE INSTANCES

- Only one subscription is necessary to run multiple instances from one 
  installation.  The total target count licensed by the subscription is 
  divided among the instances automatically:  The first instance to start 
  uses as much of the available license count as needed to license all its 
  cfg\'d targets, then a later one takes as much of that remaining as it 
  needs, and so on.  Be sure to subscribe to a level that is greater than
  the sum of the targets in all the instances, so that all will have enough 
  license count to allow checking.  When a dynamic cfg change forces a 
  reallocation of the target count the order of allocation can change.  
  Targets formerly being checked may no longer be, and vice versa, if there is 
  an insufficient license level for the total target count.  Avoid this by 
  always keeping your subscription level above your total configured target 
  count.  Enabling subscription auto upgrade for the installation 
  ( -auto command line option) will take care of this automatically for you 
  if the financial account provided accepts the increase in charges. 
  
- Starting and stopping one instance when multiple ones are running will 
  trigger a reconfiguration in the remaining running instances in order to 
  reallocate license count among all those running.  This is normally only a 
  brief event that will not affect checking if the subscription level is 
  adequate.  It only occurs, like all reconfiguration, at the end of the 
  checking loop in each, during any excess loop time.

- Multiple instances must each use a separate log file.  This is guarenteed
  when accepting the default naming provided by the program, which is the 
  recommended practice.  If configuring your own log file name and path, 
  insure that it is different for each instance.  Sharing a single log file 
  among multiple instances while running is not supported and may cause 
  erroneous or misleading log entries.  A combined log file can be created by 
  other means after each log is written, if necessary, since each log entry
  has a datetime stamp and process id. 
  

ADV____________________ INSTANCE COUNT LIMIT

- This program itself sets no arbitrary limit to the number of simultaneous 
  checking-mode instances that may be running from one installation with an 
  activated subscription.  If the watchdog feature is used each instance must 
  use a different  port.  This factor and others make it generally advisable 
  to keep the number of instances within a single installation to ten or fewer.  
  Only one instance may be run from an installation that has no activated 
  subscription, i.e. is running in free mode. 
  

ADV____________________ MULTIPLE INSTALLATIONS

  Normally only one installation of the program on any one host machine is 
  needed since multiple instances can be run from that single installation.  
  If necessary however, multiple installations can be made on one host.  
  Each will require its own subscription.  Each installation works only with
  its own web interface.  Each one will need to use a different port for that
  interface, and different ports for any watchdogs used.  


ADV____________________ AUTO DOWNGRADE

- Be aware that the automatic subscription upgrade and downgrade settings 
  function immediately upon startup of the first running instance.  This can
  cause some unexpected behavior, particularly when first configuring targets:
  If, for example, your subscription is for 500 targets but your first cfg 
  file configures only 5 targets and auto downgrade is enabled then your
  subscription will be immediately downgraded to 50 targets, the lowest 
  subscription level above 5, even though you expect to stablize your cfg
  files eventually at a higher number of targets.  A similar thing can 
  happen with auto upgrade.  Since the most likely post-installation 
  scenario is to start with a smaller number of targets and increase the 
  number after some trials, auto upgrade is enabled and auto downgrade 
  disabled by default.  These settings can be altered at any time, even 
  while running. 
 

ADV____________________ AUTO UPGRADE/DOWNGRADE LIMITS

  If using multiple instances with a subscription with automatic upgrading 
  and downgrading be aware of the following:  
  
  The number of auto upgrade requests per day and week may be limited by some 
  credit card issuers due to their activity limits policy and/or screening for
  potential fraud.  Exceeding that limit may cause them to decline further 
  changes in those periods for that reason alone. 
  
  Such a limit would apply to the subscription in total, i.e. to all of the 
  running instances.  If several instances require successive subscription 
  level upgrades when they start the limit might be reached.  If so, those 
  instances that exceed the limit will not receive any target quantity 
  upgrade until after the limit expires.  It may be preferable to upgrade 
  the subscription level manually at 
  
  www.appchkr.com 
  
  in such a case to include all the anticipated targets, avoiding any 
  possibility of hitting the activity limit, rather than relying on multiple
  more closely-spaced auto upgrade steps to increase it to the final level.
  A similar consideration applies to auto downgrading too. 

- The auto upgrade/downgrade function includes all \'nochecking\' targets in 
  its counts, just as for active targets. 


ADV____________________ DISCOVERY ( networkchkr and serverchkr types)

- The discovered targets from a hostrange will appear in the internal cfg 
  file shown in the log.  If none are discovered none will be listed in the 
  internal file nor be checked.  Such a result is not considered an error and 
  does not cause a cfg alert.  
  
  The section with the hostrange value set to cause discovery remains in the 
  internal cfg file for reference, but is *not* included in the targets that
  are checked.  Only targets found in its discovery range are included in the
  checking. These targets are indicated by the appended sequence number in 
  their section name.       

- Discovery skips address 255 for the fourth byte in IPV4 since this address 
  is commonly used for internal networking needs so rarely has an active host. 
  
- \'Host\' need not be an actual host machine when \'HostRange\' and discovery 
  are used.  Any active hosts in the range will be discovered and configured, 
  regardless of whether the first address is active or not. 

- Many organizations run Intrusion Detection Systems (IDS) on their networks
  to enhance security.  The discovery process can trigger such a system.  Use 
  the DiscoverySlowDown cfg parameter if necessary to slow down discovery 
  enough to avoid triggering an IDS alert.  Set this value to 0 to speed up 
  discovery if IDS alerts are not a concern.  Add the key 
  DSDOnlyOnFail = 1 
  in the $izD section to speed discovery if the IDS counts only failed 
  connect attempts.  
  
  The greater the number of missing or inactive hosts that are included in 
  the host range the longer discovery will take.  Since discovery runs only
  at startup, before checking begins, large values of discoveryslowdown and
  large hostranges can delay the start of checking by an hour, or more.  Run
  discovery in a separate cfg file and instance by itself to avoid delaying 
  the start of checking on known targets.   
  
- Note that multiple discovery ranges on the same port within one cfg file are 
  not checked for overlap.  Targets may appear in multiple overlapping 
  discovery ranges and will be checked as many times per loop as discovered.  
  Similarly discovery ranges, and protocols or ports, which include targets 
  already specified individually in the cfg file will result in checking of 
  those targets multiple times per loop. 
  

ADV____________________ OTHER NOTES

  Cfg keys specifying fixed point (decimal) values will also accept integers 
  in the same range as the decimal numbers. 


|;
}


sub mjD {

qq|
______________________________CONFIGURATION BASICS___________________________
                                   
In its simplest form the configuration file contains basic setup for email 
alerting, and one required configuration item per target: (hostname/url/ip).
Copy the sample basic configuration file outlined below and replace the three 
'mail...' values and the target names and values with your own to get started 
quickly. Place the resulting text file in the following directory:

$eiD$l1D$vaD 

and run it.  For the form of the run and stop command lines type at the
command prompt: 

$baD -run


BC____________________ SAMPLE BASIC CONFIGURATION FILE:

\# Alerting is optional. This [Setup] section may be omitted if alerting is 
\# not needed. 

[Setup]
    maillist        = receipient1\@youremailserver.com, receipient2\@youremailserver.com
    mailserver      = smtp.youremailserver.com
    mailfrom        = sender\@youremailserver.com

[B target 1]
    host = some-windows.host.com

[A target 2]
    host = some-linux.host.com

\# Numeric ip addresses may also be used if appropriate.
[C target 3]
    host = 192.168.1.1
\# You may also specify the protocol on the target host. 
    protocol = http
 
BC____________________ END SAMPLE FILE. 

The above targets will be checked in order by section name, so [A target 2] 
will be first in each checking loop, [B target 1] second, and so on.     

The default protocols are smb if this program is running on Windows and ssh on 
Linux.  Add the line 

protocol = ftp

to the [Setup] section to change this to ftp, for example, for all targets,
or set the protocol individually in whichever target sections desired. 

Type 

$baD -protocols

for a list of all the internally configured named protocols.  

Port number and connection method (tcp or udp) can also be specified 
individually to configure unnamed protocols:

protocol = tcp
port     = 12345

also either globally in the [Setup] section or in individual target sections.

Sensible defaults in the program normally take care of all the remaining 
details.  However, a configuration file may also contain any or all of:
(1) Setup configuration lines to alter the operating mode of the program, 
(2) Reports configuration lines to alter the reporting scheme,  
(3) Configuration lines to customize checking of targets in total and\/or 
individually. 

To see the list of all configuration parameters use the -listkeys option at  
the command line. To review a particular configuration parameter use the 
option

-findkey key_name 

To see all configuration details use the -cfg option. 
|;
}



my $ujD        = vjB.xhB.riB().h4B.'.'.kdB;  
my $qyD        = cpB.xhB.riB().h4B.'.'.scB; 
my $dmD     = nvB.xhB.riB().h4B.'_status.'.ycB; 
my $vkD     = nvB.xhB.riB().h4B.'_uptime.'.ycB; 

sub nlD {$ujD}
sub vuD {$qyD}
sub yyD {$dmD}
sub qcD {$vkD}


my $jqD = 'CFG____________________'; 
sub xlD {
qq|
_________________________________CONFIGURATION_________________________________

SUMMARY: This program is configured with a simple text configuration file 
         which is specified when starting the program.  It contains three 
         types of sections that control the operation of the program:  $izD, 
         $koD, $muD.  The first two control how the program itself 
         operates, and provide a set of defaults for all targets.  The 
         Targets section tells what targets are to be checked (one entry 
         required for each target) and allows overriding the global defaults 
         for individual targets.  This scheme allows configuring all targets 
         in bulk with the global default settings while allowing exceptions at 
         each target\'s level where necessary.  In advanced Appchkr types 
         Target sections may also be created automatically using the built-in 
         Discovery mechanism, making configuration almost totally automatic.  
         
           
SHORTCUTS: 
         Type at the command line:
          
         $baD -cfg s 
         
         to see all $izD key information, and similarly for $koD (r) and 
         $muD (t) keys. 
         
         Type 
         
         $baD -cfg
         
         to see this entire section.  
         
         Type 
         
         $baD -find characters-to-match 
         
         to see the information on those configuration keys that match those 
         characters anywhere in the name, in any section.  
         
         Type 
         
         $baD -list 
         
         for the list of all the cfg key names. 

_____________________________CONFIGURATION DETAILS_____________________________

$jqD THE FILE: 

- The configuration file consists of any number of sections of configuration 
  data lines.
- A cfg section begins with a section name enclosed in [ ] followed by one 
  or more "key = value" lines that define one named configuration value each, 
  thus:
 
[SECTION 1]
    cfg_key1 = value1
    cfg_key2 = value2
    cfg_key3 = value3
    ...     

[SECTION 2]
    cfg_key1 = value1
    cfg_key2 = value2
    cfg_key3 = value3
    ...

NOTE: SECTION NAMES ARE CASE SENSITIVE, CONFIGURATION KEY NAMES ARE NOT. 
         
- The full configuration filepathname (including extension) must use only the 
  following characters:  
  
  $aoD 

- The configuration filename must not begin with a - (hyphen).  

  \'.cfg\' is the recommended standard filename extension for cfg files on 
  both types of systems, and the only one recognzied by the user web 
  interface (UWI).  Any cfg file filename extension can be used when running 
  from the command, including none, but sticking with the recommended standard 
  will help avoid errors. 


$jqD FORMATTING: 

- Blank lines may appear anywhere and are ignored. 
- Sections should be separated by one or more blank lines for readability. 
- Comment lines start with \# as the first non-space character 
- Comment lines may appear anywhere.  
- Comment lines starting with \#\# will not print in the log. All others will.


$jqD SECTIONS: 

- Each line beginning [some section name] starts a new section.
- The name must be enclosed in brackets and should be unique:  Each occurence 
  overwrites any previous one of the same name. A duplicate section name
  causes a CFG ERROR alert.  
- The section name must contain only the following characters:

  $cxD

  Note particularly that neither brackets, [], colon, :, nor equal sign, =, 
  may appear in a section name, but internal spaces are allowed.  It may not 
  be zero or contain only spaces. 
- All leading and trailing spaces in the name are removed: 
  [name] and [ name ] are the same name.  
- Internal spaces in the name are preserved and are part of the name: 
  [Target a]  and [Target    a] are different names.   
- THE SECTION NAME IS CASE SENSITIVE: [target A], [target a] and [Target a]
  are all different names. 
- The section name is limited to $akD characters.  Text beyond that is truncated.  
  Make certain that names that are overlong for descriptive purposes are 
  unique within the first $akD characters.       
- The section name is used to identify the target in the log, in reports, 
  and in alert messages.
- The order of the target sections in the configuration file is irrelevant. 
  They are run in alphanumeric order by section name.  
- Add leading letters and numbers to the section names to control the order 
  in which they are run, e.g. A1_first_target, A2_second_target, 
  B1_some_other_target,... etc.
- Name targets consecutively that share a network segment so that they are 
  checked consecutively. Doing so will prevent alerts flooding when that 
  entire segment goes down, via the AlertsCutOff feature described below.     
- Add the word \'$ebD\' (case insensitive) immediately following 
  [any section name] to turn checking off for that particular target.  Refer 
  to the knowledge base (-kb option) for more details of this feature.     


$jqD KEYS and VALUES: 

- Only one key = value pair may appear on a data line.
- All numbers and text following the 'key = ' on a line become part of the  
  value. Omit any extraneous entries on the line after the value itself. 
- KEY NAMES ARE CASE INSENSITIVE: somekey and SomeKey are the same key.
- A key should appear only once in each section: Later keys of the same name 
  within a section overwrite any earlier ones: The earlier value is lost 
  without any warning.  
- Order of the key = value lines within a section is irrelevant. Keys with 
  related functions may be grouped together for clairity. 
- Only the keys defined below may appear in section(s) for which they are 
  defined.


$jqD SECTION TYPES: 

- An optional first section, named [Setup] (CASE SENSITIVE!), contains 
  optional configuration data to modify the default mode of operation of this 
  program itself, along with optionally settable default values for the 
  targets. 
- If present [$izD] MUST be the first section in the file.
- A optional second section, named [$koD] (CASE SENSITIVE!), modifies the 
  internal defaults for reporting of results.  This section must follow the
  [$izD] section, if present, and preceed all Target sections.  
- The sections for target systems to be checked give the details for each 
  target. 
- Only one configuration line (host url or ip) is REQUIRED for each target:

      [A target 1]
      host = some.host.com

      [B target 2]
      host = another.host.com

      [C target 3]
      host = 192.168.1.1

      ...

- Internal defaults are provided wherever possible for the remaining 
  configuration values.  All of these may be overridden in the Setup and/or 
  target sections. 


$jqD DEFAULTING: 

If a configuration key, e.g. 'somekeyname', has a default it is shown below on 
the line after its key as 'somekeyname_d'. Defaults are normally used either 
when the key is not present in the file (missing) or is specified with an 
empty value thus:

somekeyname =

Exceptions are noted below.  For instance, a few configuration keys use the 
empty value to turn off a feature and only use the default if the key is 
missing. Such behavior is explicitly noted where applicable.

Refer to the cfg files included in the distribution for illustrations of 
the wide range of operation with minimal effort that this makes possible.


$jqD UPDATING (DYNAMIC) CONFIGURATION: 

By default the cfg file is checked on each pass of the main loop and read 
if changed. Thus it may be changed while this program is running, as often 
as required, without restarting, by simply updating the file with new values
and saving it.  Configuration changes are only implemented after a loop 
completes: No changes are made within one loop. The cfg file is copied to the 
log each time changes are implemented so that the configuation in effect at 
any point in time is known.  This dynamic behavior may be disabled in the cfg 
file at any time, requiring a restart of the program to accept any later 
updates to the cfg file.

Changes to the LogFilePath value are always ignored, however, after startup. 
This value is a static exception that cannot be changed after startup. Only the 
initially configured value is used within a session. Restart the program with 
the modified value in the cfg file to change it.

No internal program variables restart when the cfg file is updated. For 
instance alerting slowdown status, or program runtime or loopcount do not
change.  Be aware that changing either of these latter two limits on update to 
values that have already passed can cause immediate shutdown after 
reconfiguration. Similarly any relevant alerts will continue to be supressed 
after the reconfiguration by whatever slowdown values might be in effect, just
as though no reconfiguration had occurred.  Of course if a target whose alerts
are being slowed down has checking disabled by the reconfiguration no further 
alerts will occur until it is enabled again.  A NoChecking - resume-checking 
cycle for a target restarts alerting slowdown for that target. 

Use this dynamic update feature to change mail and text list receipients, 
targets to be checked, or any other configurable items, between shifts, or 
between weekdays and weekends, between day and night, or on some other schedule.  
Simply overwrite the cfg file with a copy having the relevant items changed.  
Automate the overwriting with crontab on linux or the task scheduler on Windows. 

Note that changing the name of a target section while dynamic configuration is
in effect deletes all the information (uptime, history etc.) under the old 
name and starts anew with the new name.  


$jqD ALERTING: 

Alerting can be done thru a syslog server, thru an email server (which also
makes possible sending text alerts), or both.  

A 'mailfrom' email address is a required configuration key in the [Setup] 
section if email and/or text alerting are desired.  A maillist of 
receipients, and the url of the mail server hosting the 'mailfrom' address 
must also be supplied.  

The email server configured must be accessible to this program while it is 
running: Check for intervening firewalls or other network issues that may 
prevent this program from sending email through that server.  

Operation will be most reliable if the mailserver is 'local', i.e. behind the 
same firewalls as this program, and able to receive mail from the location 
of this program on the network.  In some organizations the desktop section of 
the network is blocked against the standard (SMTP) method of emailing that is 
used by this program.  In that case select a host machine for this program 
that lies on a network section that does allow SMTP emailing, typically one 
hosting servers, if alerting is desired.   

Note that only "internet email" style addresses, including an "@" sign, are 
accepted by this program.  UNIX mail and other types of emailing are not 
currently supported.  

Text alerting to mobile phones is also possible when the Email alerting method 
is selected.  Text alerts are sent only for high criticality targets when 
texting is enabled.  View the -text option for details, and the description 
of the related configuration parameters, such as \'textlist\', below.  
 
Syslog alerts can be sent to a remote syslog server in lieu of or in addition 
to email and text alerts.  The choice of alerting method can be configured
at the global level and customized by target where necessary, as well as the 
details of each method.  

If alerts are enabled an alert is always sent on startup and on configuration 
update.  If this alert is not seen on one of these events be sure to check the 
local log for any issues detected relative to alerting: If alerts cannot be
sent due to one or more causes reviewing the local log at startup or 
reconfiguration will be the best way to learn of the issues.  If a global 
default alerting setup is not configured this fact is also noted in the 
reports as an additional precaution.   However, if alerts are configured but 
there is an error in the configuration that prevents alerting, or the alerting 
connection over the network fails, or there is a failure at the remote alerts 
server, the log will still be the only place to learn of the problem.  

Alerting rates are limited in two cases to avoid flooding email and text 
receipients or the syslog receiver with unnecessary messages: 
(1) A target is unresponsive for a long period (alertslowdown). 
(2) Many consecutive targets are down in one polling loop (alertcutoff).  
Refer to the details in the description of the related configuration paramters 
below.  


$jqD MISC: 

Selected Appchkr types will discover which hosts over a range of addresses are 
active for a particular protocol.  See the description of the \'HostRange\' key.   
Type

$baD -findkey hostrange 

Note that the program does not detect nor prevent multiple entries for the 
same host and port combination.  Each occurence will be checked in its 
configured order, and frequency or interval without regard to the others.  
This feature may be used to advantage in troubleshooting networking issues. 


$jqD SHORTCUTS: 

- Use the -list command line option to list all the defined cfg keys
- Use the \' -findkey   text-to-match \' option to list all keys containing text  
  matching that given.  
- Use the -cfg option followed by the word \'$izD\', \'$koD\', or \'$muD\'
  (case insensitive) to see just the configuration key descriptions of that 
  type.   


THE ALPHABETICAL LIST OF ALL THE DEFINED CONFIGURATION KEYS AND THEIR 
DEFAULTS AND USE, BY SECTION, FOLLOWS. 

  |; 
} 


no warnings;  
my %xjD =  
    ($izD      => {
MailFrom            => qq|An email address from which all emails and text 
                    messages are sent.  Must be a valid email address at a 
                    valid SMTP email server specified in the MailServer key.  
                    Required if text or email alerts are desired. If this key
                    is missing direct email and text alerting messages from 
                    this program will not be possible.  Syslog alerts will 
                    still be possible.  Refer to the notes on ALERTING in 
                    CONFIGURATION DETAILS in the full configuration 
                    documentation for more information.  
                    
                    We strongly recommend for security that this email account
                    only be used for this purpose and not shared. 
                    
                    Must be only a single email address. 
                    
                    May not be empty. 
                    
                    No default.\n|,

MailFromPswd        => qq|Password for the mailfrom account. It is used to login 
                    to the \'MailFrom\' account to make possible sending text 
                    messages and emails to outside addresses. Many email 
                    servers will only send emails to other (external and 
                    remote) servers if the sender is logged in. Some email 
                    servers may require password login even for internal email.  
                    
                    Secure the password by enciphering it with the -encipher 
                    (-e) commandline option of this program and/or by limiting 
                    read permission on the cfg file to the account that runs 
                    this program.  Securing the password by any other means 
                    will  prevent successful login by this program to the 
                    mailfrom account, possibly preventing sending alerts. 
                    
                    May not be empty. 
                    
                    No default.\n|,
                   
MailServer          => qq|Url or ip address of the email server for the 
                    \'MailFrom\' address.  Required if alerts are desired.  
                    
                    Accepts only the following characters:
                    
                    $pfD   
                    
                    May not be empty. 
                    
                    No default.\n|,
                    
MailServerPorts     => qq|Non-standard port numbers for the email server to be
                    used to send email and text alerts.  Only use this key if 
                    that email server does not listen on the standard port 
                    numbers (25 and 587) or if it also listens on non-standard 
                    port numbers in addition to the standard ones and you wish 
                    to use one or more of these non-standard numbers.  The first 
                    port number in this list to connect will be used thereafter. 
                    
                    A comma separated list of port numbers, each > 0 and < 65535.
                    
                    May not be empty.\n|,
                    
MailServerPorts_d   => join (',', sxB) , 
                    
AdminMailList       =>qq|Operational error emails about this program itself 
                    and configuration issues are sent to these email addresses.
                    A confirming email is sent to this maillist on startup and 
                    on every cfg file change while running. If missing it 
                    defaults to the contents of 'maillist'.  Use the empty 
                    value (adminmaillist = ) to prevent this and to prevent 
                    any of these general and configuration alerts from being 
                    sent.
                    
                    Comma-separated list of valid email addresses. 
                    
                    May be empty.                    
                    |,  
                    
AdminMailList_d     =>"Content of 'maillist'",
                                      
LogFilePath         => qq|Absolute file location to which to write the program 
                    runtime log.  Consult this log whenever questions arise 
                    about the runtime activity.  All actions the program takes, 
                    the results, and their explanations are logged there. 
                    
                    Absolute filepathname. 
                    
                    May not be empty.                    
                    |,
                    
LogFilePath_d       => "$eiD$l1D$ujD",

WatchdogPort        => qq|This program listens for connections on this port number 
                    if configured.  Other running instances of this program 
                    can connect to this one on this port to verify that it is 
                    running. Run a watchdog instance on another host machine 
                    and configure it to check this one. Verify that any port 
                    number chosen is not already used by other programs on 
                    this machine, e.g. by typing the command (on either type 
                    of system):
                    
                    netstat -an 
                    
                    Port 5510, if not in use, is suggested for the first 
                    instance of $baD, and the following integers for 
                    additional instances.  When multiple instances of this 
                    program are run on one machine, each instance with a 
                    watchdog port, then each instance must configure a 
                    different port. A port number can only be used by one 
                    instance on a given host machine. 
                    
                    Refer to the knowledge base for more information on 
                    choosing a port number.  
                    
                    If this key is missing no listener is activated and no 
                    watchdog monitoring can occur.  
                    
                    An integer between 1 and 65535. 
                    
                    May not be empty.                    

                    No default.\n|,   

MinLoopTime         => qq|Use this key only if the schedule for checking targets 
                    is configured by loop count through the use of the 
                    \'Frequency\' key.  Omit this key (accept the default) if 
                    the checking schedule is configured exclusivly through the 
                    use of time differences via the \'interval\' key .
                    
                    When used with \'Frequency\' this key sets the minimum time 
                    interval > or = $vyD, in fixed point minutes, 
                    for starting one loop to cycle through all the targets. 
                    This value is only the minimum: The actual time taken by 
                    any one loop may exceed this value by any amount, 
                    depending on the activity and delays in the loop.  
                    
                    CAUTION: THIS VALUE MUST BE LESS THAN ANY INTERVAL VALUE 
                    CONFIGURED.  THE PROGRAM MAY ADJUST THE VALUE INTERNALLY 
                    TO INSURE THIS, OVERRIDING A CONFIGURED SETTING.
                    
                    Fixed point (decimal) minutes > or = $bsD .
                    
                    May not be empty.                                        
                    |,
                    
MinLoopTime_d       => $vyD,

InterstepDelay      => qq|Time between checking each target (i.e. between each 
                    monitoring poll, each connection attempt) within one loop. 
                    Use this key to trade off network polling load vs. 
                    response latency: The larger the value the lower the load, 
                    but the greater the lag time or latency before a changed 
                    status is noted.  Use a positive value for smaller 
                    networks with more limited bandwidth and a smaller number 
                    of targets to be checked.  Set it to zero on large 
                    networks with plenty of available bandwidth to accomodate 
                    the additional polling load and a greater number of 
                    targets to be checked.  Affects all targets equally -- 
                    not customizable at the individual target level.
                    
                    Integer seconds > or = 0 
                    
                    May not be empty.             
                    |,
                    
InterstepDelay_d    => 1,

MaxLifeTime         => qq|Run time limit in hours. A 0 value means no 
                    lifetime limit.  If missing runs until stopped externally.
                    
                    Zero or positive fixed-point hours. 
                    
                    May not be empty.
                    |,
MaxLifeTime_d       => 0,

MaxLoops            => qq|Polling loop count limit.  A 0 value stops excution 
                    after initialization but without checking any targets and 
                    can be useful for initial testing of new configurations.  
                    Positive integer values stop execution at the beginning of 
                    that loop (i.e. before checking starts.)  If both MaxLoops 
                    and MaxLifetime are used the first limit to be reached 
                    stops execution.  If neither is used runs until stopped 
                    externally.
                    
                    An positive or zero integer count value. 
                    
                    May not be empty.
                    |,
MaxLoops_d          => 2**32,

MaxLogSize          => qq|Size limit of the log beyond which it is restarted.  
                    One previous copy is kept.  0 for no size limit.  
                    \'MaxLogSize\' and \'MaxLogAge\' may both be used: The 
                    first to be reached will restart the log. 
                    
                    Positive integer Megabytes. 
                    
                    May not be empty.                    
                    |,
MaxLogSize_d        => 100,

MaxLogAge           => qq|Age of the log in days beyond which it is restarted.  
                    One previous copy is kept.  0 for no age limit. MaxLogSize 
                    and MaxLogAge may both be used: The first limit to be 
                    reached will restart the log. 
                    
                    Integer days >=0. 
                    
                    May not be empty.                    
                    |,
MaxLogAge_d         => 40,

HeartbeatPeriod     => qq|If this value is set and alerting is enabled this 
                    program sends a periodic alert to confirm that the 
                    program is running and checking targets. A value of 1 
                    sends the alert every hour on the hour, 2 every other 
                    hour on the hour, 3 every third hour on the hour, and so 
                    on up to 24 which sends it every day at midnight.  
                    
                    One of the integers 1, 2, 3, 4, 6, 8, 12, or 24
                    
                    May not be empty.                     
                    |, 
HeartbeatPeriod_d   =>24,

StaticConfig        => qq|Selects static (1) or dynamic (0) configuration.  
                    Dynamic configuration accepts and processes configuration 
                    file changes while the program is running.  Static
                    configuration does not: A restart of the program is 
                    required for a configuration change.  Accepting the 
                    default (0) of dynamic configuration allows adapting the 
                    program automatically while running to shift differences, 
                    day-night changes, weekday-weekend differences, server or  
                    network reconfiguration, and so on.  See the entry in the 
                    knowledge base (option -kb) for more information.
                    
                    May not be empty.                                       
                    |,
StaticConfig_d      => 0,

SysLogHost          => qq|A syslog server to receive alerts via the syslog 
                    protocol.  VERIFY THIS VALUE CAREFULLY!  CHECK THE LOGS 
                    AFTER STARTUP to be certain that communication is 
                    occuring successfully with the syslog server, especially 
                    if syslog is specified as the only alerting method.  An  
                    error in this value prevents alerting by syslog. 
                    Consulting the program\'s log and the destination syslog
                    will be the only way to learn of that problem.  
                    
                    Host url or ip address 
                    
                    May not be empty.  
                    
                    No default. \n|,

SysLogPort          => qq|Port number of the syslog server to receive alerts.  
                    VERIFY THIS VALUE CAREFULLY! CHECK THE SYSLOG AFTER STARTUP 
                    to be certain that communication is occuring successfully 
                    with the syslog server, especially if syslog is specified 
                    as the only alerting method.  An error in this value 
                    prevents alerting by syslog and consulting the syslog 
                    will normally be the only way to learn of that problem. 
                    
                    An integer between 1 and 65535.  
                    
                    May not be empty.                   
                    |,           
SysLogPort_d        =>514, 
                    
SysLogMethod        => qq|UDP or TCP (case insensitive) to select the transmission  
                    method for sending alerts to a syslog server.  TCP is more 
                    reliable if the syslog server supports it, especially over 
                    public networks.  Although less reliable, UDP is the 
                    legacy standard since it causes less network traffic. 
                    CAUTION: If UDP is used verifying successful communication 
                    on the syslog server itself is the only way to confirm 
                    that alerts are reaching it from this program.     
                    Failure-to-deliver information is not provided by UDP. 
                    
                    Either UDP or TCP 
                    
                    May not be empty.                    
                    |,
SysLogMethod_d      => 'UDP',

SysLogFacility      => qq|Numeric facility code for this prgram to include in all 
                    syslog messages sent.  This code allows distinguishing 
                    this sender from others in the composite data of the 
                    syslog.  Use option -slf at the command line to see the 
                    list of commonly-used names for the codes.
                    
                    An integer between 0 and 23.  
                    
                    May not be empty.  
                    |,
SysLogFacility_d    =>14, 

DiscoverySlowDown   =>qq|Insert a minimum delay of this amount between each 
                    target discovery attempt, primarily to prevent triggering
                    Intrustion Detection System (IDS) alerts, or to test an
                    IDS.  Use a value of 0 to make discovery as fast as 
                    possible if IDS alerts are not a concern.  
                                       
                    Integer seconds between 0 and 10 . 
                    
                    May not be empty. 
                    |,
DiscoverySlowDown_d => 5,

DSDOnlyOnFail       =>qq|A boolean (true/false) value to apply the 
                    DiscoverySlowDown delay only after a failed discovery 
                    attempt.  If all addresses to be discovered are active
                    and respond this key will have no effect.   If the 
                    discovery address range is sparsely populated it will 
                    help speed discovery if IDS monitoring only counts failed 
                    attempts, or use it to test such a system. 
                    
                    1 to apply the delay only on failure, 0 otherwise. 
                    
                    May not be empty. 
                    |,
                    
DSDOnlyOnFail_d    => 1,




Protocol            => qq|Global default communication protocol to be checked on 
                    each target. (e.g. ftp, http, smtp, Oracle, etc.)   
                    Specifying the protocol automatically specifies checking 
                    connectivity to the standard port of that protocol and by 
                    the underlying IP method (tcp or udp) of that protocol.  
                    The protocol must be one given in the list displayed by 
                    the -protocol command line option.  For a protocol not in 
                    that list set this key to tcp or udp, as appropriate,  
                    and \'port\' keys to the correct values for that protocol. 
                    To default to a non-standard port for a listed protocol 
                    set this value to the listed protocol and put the 
                    non-standard port number in the \'port\' setting in this 
                    section. 
                    
                    UDP or TCP or protocol name defined in the -p list. 
                    
                    May not be empty. 
                    |, 
Protocol_d          => kbB() ? 'smb' :'ssh',

Port                => qq|Global default port number to be checked on each host. 
                    Normally this setting is not needed.  Use it only to 
                    specify a non-standard port for a listed protocol 
                    ( -protocol command line option), or to create a default 
                    for a protocol not in that list.  In this latter case the 
                    required IP method (tcp or udp) must also be specified in 
                    the \'protocol\' setting. 
                    
                    An integer between 1 and 65535.  
                    
                    May not be empty.  
                    
                    No default.\n|,

Interval            => qq|Global default minimum checking interval in minutes.
                    The program waits this long before making another check on
                    a target, unless overridden at the individual target level.
                    This value is only the minimum, to reenable the next check
                    of a target.  The actual time period may be longer than 
                    this, depending on delays and other activity in the loop.

                    If it is anticipated that a fair number of targets will 
                    need to be customized from this default value it may be 
                    more convenient to use frequency (loop count) to schedule 
                    polling. Use of frequency allows changing the default 
                    polling period globally using \'MinLoopTime\', and having 
                    all targets, even those customized with their own 
                    frequency value, adjust while maintaining the same 
                    relative frequency of polling among them.  
                    
                    CAUTION: IF THE FREQUENCY VALUE IN THIS SECTION IS 
                    NON-ZERO THE INTERVAL VALUE IS IGNORED.
                    
                    Fixed point (decimal) minutes > or = $bsD .  
                    
                    May not be empty.  
                    |,
Interval_d          => 2.0,

Frequency           => qq|Global default number of loops between connection 
                    attempts to each target.  A 0 value sets the global 
                    default to ignore loop count and use \'Interval\' only.
                    Using frequency rather than time intervals allows 
                    adjusting loop timing with just MinLoopTime or 
                    InterstepDelay while maintaining the relative frequency 
                    of checking of all targets, even those which have a 
                    customized individual frequency value set. 
                    
                    CAUTION: IF FREQUENCY IS NON-ZERO HERE, INTERVAL 
                    (TIME-BASED CHECKING) WILL BE IGNORED ON ALL TARGETS THAT 
                    DO NOT OVERRIDE IT BY SETTING 
                    
                    frequency = 0 
                    
                    IN THEIR OWN SECTION, EVEN IF THEY HAVE A VALID INTERVAL 
                    SETTING THERE.
                    
                    Integer number of loops > or = 0
                    
                    Zero enables checking by time (Interval) globally.
                    
                    May not be empty.
                    |,
Frequency_d         => 0,

MailList            => qq|Comma separated list of email addresses to receive email 
                    alerts for high and medium criticality targets. If empty 
                    (maillist = ) or missing, targets will default to no alerts 
                    (Can be overridden in each target section.) 
                    
                    Comma-separated email list. 
                    
                    May be empty.
                    
                    No default.\n|,

TextList            => qq|Comma separated list of phonenumber\@emailportal text 
                    addresses (e.g. 1234567890\@vtext.com) to receive text 
                    message alerts on high criticality targets.  Use the 
                    -texting option to learn more about sending text messages 
                    via email.   If missing or empty (textlist = ) targets 
                    will default to no text alerts. (Can be overridden in each 
                    target section.)
                    
                    May be empty. 
                      
                    No default. \n|,
                    

AlertDirection      => qq|A global default defining which target status change 
                    direction causes a failure alert and log message: UP or 
                    DOWN.  This key affects the logging and reporting of 
                    target status changes as well, even if alerting is not 
                    enabled.  Setting this key to UP (i.e. alerting on up) 
                    disables the use of ReportGroups.  See the 
                    KnowledgeBase option (-kb) for additional information and 
                    cautions on using this cfg key.  
                    
                    UP or DOWN, case insensitive. 

                    May not be empty.
                    |,
AlertDirection_d    => 'DOWN', 

AlertMethod         => qq|A comma-separated list of one or more global default 
                    methods to be used for sending alerts: 
                    - Email, (allows text alerts directly from this program)  
                    - Syslog (no direct text alerting)  
                    Enter the methods desired as a comma-separated list on the 
                    same line as the key. The names are case insensitive.  Use
                    the empty value to stop all alerting and program complaints
                    about the lack of alerting. 
                    
                    Email and/or syslog, case insensitive. 
                    
                    May be empty.
                    |,
AlertMethod_d       =>'Email', 

AlertSlowDown       => qq|Global default control to gradually reduce the rate of 
                    alert messages for targets which are continuously down. A 
                    value of 1 slows down alerting to prevent flooding of 
                    email and text receipients or syslog servers with failure 
                    messages on every loop.  Only alerting slows down: Polling 
                    of the targets and logging continue at configured rates.  
                    A 0 value sends every alert without slowdown.  If 
                    AlertDirection = UP then AlertSlowDown applies to alerts 
                    issued for targets continuously in the \'up\' state rather 
                    than \'down\'.
                    
                    A value of 0 or 1
                    
                    May not be empty. 
                    |,
                    
AlertSlowDown_d     =>1,

Criticality         => qq|Sets the global default logging, alerting, and reporting 
                    level: 
                    HIGH = logging, reporting and alerting by email and text,
                    MEDIUM = logging, reporting and alerting by email only, 
                    LOW = logging and reporting only (no alerts).  
                    A HIGH alert message begins with $tnD, and MEDIUM 
                    with $fyD .  Targets are grouped in reports in 
                    descending order of criticality.  Typically the global 
                    level is set to MEDIUM so that only a few selected targets 
                    need to be set to HIGH or LOW.  Case insensitive.  
                    
                    A value of \'HIGH\', \'MEDIUM\', or \'LOW\'
                    
                    May not be empty.
                    |,
                                        
Criticality_d       => (irB)[1],

AlertCutOff         => qq|The number of consecutive target connect failures after 
                    which no further alerts wiil be sent for the remainder of 
                    that loop.  Prevents email and text flooding when a large 
                    segment of a network goes down if those targets are 
                    checked consecutively.  A single warning email is sent 
                    when this occurs.  Name targets consecutively (add a 
                    prefix) that share a network segment to take advantage of 
                    this feature.  
                    
                    Integer > $tgD .  
                    
                    May not be empty.
                    |,
                    
AlertCutOff_d       => $arD, 

UseIP               =>qq|Selects the use of a numerical IP address rather 
                    than a hostname (FQDN) for checking all targets.  This 
                    program converts, if  possible, any target hostname 
                    supplied to a numerical IP address before beginning 
                    checking.  This conversion occurs everytime the cfg file 
                    is read.  A value of 0 prevents this conversion -- the 
                    supplied URL given for all targets is used as entered in 
                    the cfg file, whether a hostname or a numerical IP address.
                    
                    Using IP addressses may be very slightly faster and is 
                    most suited to networks with static address assignments, 
                    without a local DNS server, or with very long and stable 
                    DHCP leases or reserved addressses.  However, if checking 
                    the DNS lookup process is a desired part of the overall 
                    checking process set this parameter to 0 and use hostnames 
                    in all \'Host\' values.  
                    
                    One of these two values: 
                    0 => checking loop uses host value as given in cfg
                    1 => checking loop uses numerical IP address for each host
                    
                    May not be empty.
                    |,   
                    
UseIP_d             => 0, 

},

    $koD    => {
StatusFilesPath     => qq|Absolute filepathname for the status report file for
                    individual targets.  Use only the .rpt extension for this 
                    filename to make it visible in the user web interface.
                    The related group status report filename, if any, is 
                    derived from this name by adding \'_groups\' to the base 
                    name. 

                    A valid absolute path and filename. 
                    
                    May not be empty.
                    |,
                                        
StatusFilesPath_d    => $eiD.$l1D.$dmD,

StatusUpdate        => qq|Integer loop count between updates of the status files.
                    A value of 1 updates the status files after every loop, 2 
                    after every other loop and so on.  Status files are only 
                    written at the end of a checking loop.  Should normally be 
                    set to 1, or accept the default, to guarentee the most 
                    up-to-date reports.  Turn status reporting off with the
                    StatusOn key. 
                    
                    Status data is collected on each loop.  This key only 
                    controls the reporting of that data. 
                    
                    An integer loop count > = 1
                    
                    May not be empty.
                    |,
                    
StatusUpdate_d      => 1,

StatusOn            => qq|A value of 1 enables the status report for individual 
                    targets.  A value of 0 prevents writing a new individual 
                    status file on every loop and deletes any existing file. 
                    
                    1 to enable individual status reporting, 0 to disable it. 
                    
                    May not be empty.
                    |,
                    
StatusOn_d          => 1,

GroupStatusOn       => qq|A value of 1 to write a GroupStatus report file, or 
                    a value of 0 to prevent writing any group status file.  
                    At least one ReportGroup must be named in two or more 
                    target sections to create a group status report.  
                    
                    1 to enable group status reporting, 0 to disable it. 
                    
                    May not be empty.
                    |,
                   
GroupStatusOn_d     => 0, 

UpTimeFilesPath     => qq|Absolute filepathname for the uptime report file for 
                    individual targets.  Use only the .rpt extension for this 
                    filename to make it visible in the user web interface.  
                    The related group uptime report filename, if any, is 
                    derived from this name by adding \'_groups\' to the base 
                    name. 

                    A valid absolute path and filename. 
                    
                    May not be empty. \n|,

UpTimeFilesPath_d   =>$eiD.$l1D.$vkD,

UpTimeUpdate        => qq|Integer loop count between updates of the uptime report
                    files.  A value of 1 updates the uptime files after every 
                    loop, 2 after every other loop and so on.  The uptime 
                    files are only written at the end of a loop.  Should 
                    normally be set to 1, or accept the default, to guarentee 
                    the most up-to-date reports.  With a very large list of 
                    targets a small percentage of loop time may be saved by 
                    setting this value higher than 1.  Turn uptime reporting
                    off with the UpTimeOn key. 
                    
                    Uptime data is collected on each loop.  This key only 
                    controls the reporting of that data. 
                    
                    An integer of 0 or greater. 
                    
                    May not be empty.
                    |,
                    
UpTimeUpdate_d      => 1,

UpTimeOn            => qq|A value of 1 enables the uptime report for individual 
                    targets.  A value of 0 prevents writing a new individual 
                    uptime file on every loop.  Copies of existing uptime 
                    reports are saved when the program starts if uptime 
                    reporting is enabled. 
                    
                    1 to enable individual uptiime reporting, 0 to disable it. 
                    
                    May not be empty.
                    |,
  
UpTimeOn_d          => 1,  

GroupUpTimeOn       => qq|A value of 1 to write a GroupUptime report file at the
                    same time and path that an individual uptime report file is
                    written, or a value of 0 to prevent writing any group 
                    uptime file.  At least one report group must be defined in 
                    two or more target sections to create a group uptime file.  
                    
                    0 for no GroupUptime report or 1 to enable it. 
                    |,
                    
GroupUpTimeOn_d     => 0, 

NoUpTime            => qq|Defaults all target sections to be excluded from the 
                    uptime report.  Override it with the same key in selected 
                    target sections in a large system, to keep the report 
                    small and confined only to those targets that need it.  
                    Checking and recording of uptime continues while uptime 
                    reporting is disabled.  Only its reporting is affected by 
                    this key.  Omit this key if uptime reporting is desired 
                    for all targets. 
                    
                    A value of 1 (disable uptime globally) or 0 (enable).
                    
                    May not be empty. 
                    |,
                    
NoUpTime_d         => 0, 

UpTimeFilesAge      => qq|Length of time in days to keep previous uptime reports.
                    Report files older than this value will be deleted.   
                    
                    Integer days between 1 and 400 
                   
                    May not be empty. 
                    |,
                   
UpTimeFilesAge_d    => 40,

ReportPeriod        => qq|A period of time in days for the reports.  The reports 
                    start again from zero after each period elapses.  When 
                    this key is used the first and last reports will normally 
                    be for partial periods unless $baD is started and 
                    stopped exactly on the boundaries of the report period. 
                    The reports restart with the new period when it is changed 
                    in a dynamic reconfiguration.  The previous report, 
                    normally for a partial period, is saved. 

                    One of the following integer values: 
                    0 => no restarting of the reports 
                    1 => every day starting at local 0000 hrs. 
                    5 => Week days (M - F) starting at local 0000 hrs. Monday
                    7 => A calendar week starting at local 0000 hrs. Sunday
                    14 => Two weeks starting at local 0000 hrs. Sunday
                    28 => Four weeks starting at local 0000 hrs. Sunday
                    30 => A calendar month starting at 0000 hrs. of the 1st day
                    90 => A calandar quarter starting at 0000 hrs. the 1st day
                    
                    May not be empty.
                    
                    Choosing 5 for week days will also create an additional 
                    two day report for the weekend.  
                    
                    The actual day count for 30 and 90 will vary slightly, 
                    depending on the month or quarter in question.  
                    |,

                  
ReportPeriod_d      => 30, 

},

    $muD   => { 
        
 " REMINDERS: ",  qq|- Names of target sections are limited to $akD characters.
                    Changing the name of a target in a dynamic cfg change makes
                    it a new target, erasing all existing data\n|,
                     
Host                => qq|REQUIRED: Hostname (FQDN) or ip address of a target\'s 
                    host machine.  Use this key by itself to set up a host 
                    address for a single target, or in conjunction with 
                    \'HostRange\' to initiate discovery of a range of targets.  
                    \'HostBegin\' may be used as a synonym.  Accepts only the 
                    characters: 
                    
                    $pfD
                                          
                    May not be empty.  
                    
                    No default.\n|,
                                        
HostRange           => qq|Specifies the number of hosts to attempt to discover 
                    following the \'Host\' or \'HostBegin\' IP address.  If 
                    this key is missing only a single host at \'Host\' will be 
                    configured and checked.  This key initiates automatic 
                    discovery and configuration of any hosts in this range 
                    which are active for the configured protocol, starting with 
                    the IP address of the \'Host\' value.  If no \'Host\' nor
                    \'HostBegin\' key is present in this section this key is 
                    ignored:  Both must be present to initiate discovery.    
                    Multiple discovery sections may be used.  This cfg key and 
                    discovery can only be used when running with an activated 
                    subscription.  Use of this key in free mode generates a 
                    cfg error.  
                    
                    Discovery stops when the fourth byte of the IP address
                    being incremented reaches 255, or when the configured 
                    number of addresses has been queried, whichever comes 
                    first. Thus if hostbegin = 10.0.0.128 and hostrange = 255, 
                    for example, only 127 addresses will actually be queried:
                    Querying stops at address 10.0.0.255.  If instead 
                    hostrange = 100, querying stops at address 10.0.0.228.  
                    The hostbegin value must have 1 in the fourth byte of the 
                    address to allow querying a full 255 addresses for one 
                    discovery section name.   
                                        
                    Discovered hosts, i.e. those which respond to the 
                    protocol and/or port configured in this discovery section, 
                    become target entries in the internal configuration 
                    maintained by the program, with the configuration given 
                    in this section.  They are listed in the log file as a new 
                    target with a sequence number appended to the section name 
                    which defines the discovery range.  Each of these targets 
                    also shows individually in the status and uptime reports.  
                    Note that the base section name may be truncated when 
                    making these new section names to keep within the $akD 
                    characters limitation for the length of section names.
                    
                    CAUTION: Discovery runs only during startup, before 
                    checking begins.  Discovery cannot currently be changed nor  
                    initiated dynamically, while checking is running.  Changing 
                    any one of the four discovery-related cfg keys (host, 
                    hostrange, port, protocol) in a discovery section or 
                    adding a hostrange dynamically stops the program.  Restart 
                    the program to run or rerun discovery.  Other cfg keys in 
                    an active discovery section may be changed dynamically. 
                    Dropping discovery (removing the hostrange key) can also be
                    done dynamically.  Any previously discovered targets are 
                    removed and the former discovery section now serves as an
                    ordinary target section for a single target at \'Host\'.    
                    
                    An integer between 2 and 254.     
                    
                    May not be empty.  
                    
                    No default.\n|,
                    
Protocol            => qq|Selects the port number and IP connection method to be 
                    used when checking this target, based on the standard 
                    values for that protocol.  The standard  protocols and
                    their port numbers and connection methods are given by 
                    the -protocol command line option.  For a protocol not
                    listed there set this key to the correct IP method, tcp or 
                    udp, as required (normally tcp), and \'Port\' key to the 
                    correct values for that protocol.  To override the default 
                    port number or IP method for a listed protocol set the 
                    \'Port\' key to the desired value and this key to the 
                    required IP method.  Otherwise do not use the port key. 
                                        
                    Target hosts that have several protocols running may have 
                    each one checked in one configuration file by using a 
                    separate target section for each. 
                    
                    A valid listed protocol abreviation.

                    May not be empty. 
                    
                    Overrides any global default. \n|,
                    
Port                => qq|Port number to check on the target.  Normally not 
                    needed, the global default is used or that given by the
                    \'Protocol\' setting or default.  Use this value to 
                    override the standard port defined for a protocol, to 
                    override a global default, or to set up a port for a 
                    protocol that is not built in.  In that latter case the 
                    IP connect method must also be specified as tcp or udp in 
                    the protocol setting for this target. 
                    
                    An integer between 1 and 65535.
                    
                    May not be empty.  
                    
                    Overrides any global default. \n|,
                    
Interval            => qq|Minimum time interval between checking this target.  
                    This value is only the minimum, to reenable the next check
                    of the target.  The actual time period may be longer than 
                    this, depending on delays and other activity in the loop 
                    prior to reaching this target in the checking order.
                     
                    CAUTION: IF FREQUENCY IS NON-ZERO THIS INTERVAL SETTING IS 
                    IGNORED FOR THIS TARGET.
                    
                    Fixed point (decimal) minutes > or = $bsD .
                    
                    May not be empty. 
                    
                    Overrides the global default. \n|,
                    
Frequency           => qq|Number of loops between checking attempts.  Use this 
                    key to maintain the relative frequency of checking of all 
                    targets when adjusting the overall loop period with 
                    \'MinLoopTime\', \'InterstepDelay\' and other factors. 
                    The minimum loop period is set by \'MinLoopTime\' .  The 
                    actual value can be anything larger than this, depending 
                    on the amount of activity and delay in the loop.
                    
                    CAUTION: IF FREQUENCY IS NON-ZERO, INTERVAL (TIME-BASED 
                    CHECKING) IS IGNORED FOR THIS TARGET, EVEN IF A VALID 
                    VALUE EXISTS.
                    
                    Must be 0 or a positive integer.  
                    
                    Zero enables checking scheduled by time (Interval).
                    
                    May not be empty 
                    
                    Overrides the global default. \n|,
                    
MailList            => qq|Comma separated list of email addresses to receive alerts 
                    for high and medium criticality targets. If empty 
                    (maillist = ) no email alerts will be sent for this target. 
                    If missing the global default maillist, if any, is used.
                    
                    May be empty. 
                    
                    Overrides the global default. \n|,
                    
MailListAdd         => qq|List of email receipients to add to the global list.
                    The resulting list is used for this target if no 
                    \'MailList\' key is present in this section.  Ignored 
                    if the \'MailList\' key is present.  Attempting to add an 
                    email address already present causes a cfg warning.  If 
                    the global MailList is empty the effect of this key is 
                    the same as the \'MailList\' key.  Adding and removing 
                    the same email address for a target produces unspecified 
                    results. 
                    
                    May not be empty.
                    
                    No default. \n|,
                    
MailListRemove      => qq|List of email receipients to remove from the global 
                    maillist, if present and not empty. The resulting list is 
                    used for this target if no \'MailList\' key is  present in 
                    this section.  If a non-empty \'MailList\' is present in 
                    this section this key is ignored.  Attempting to remove a 
                    non-existent email address causes a cfg warning.  Removing 
                    and adding the same email address for a target produces 
                    unspecified results. 
                                     
                    May not be empty.
                    
                    No default. \n|, 
                    
TextList            => qq|Comma separated list of phonenumber\@emailportal text 
                    addresses (e.g. 1234567890\@vtext.com) to receive text 
                    message alerts on high criticality targets.  Use the 
                    -texting option to learn more about sending text messages 
                    via email.  If empty (textlist = ) no text alerts will be 
                    sent for this target.  If missing the global default 
                    textlist, if any, is used.
                    
                    May be empty.
                    
                    Overrides the global default, if any. \n|,
                    
TextListAdd         => qq|List of text receipients to add to the global textlist,
                    if present and not empty. The resulting list is used for 
                    this target if no \'TextList\' key is  present in this 
                    section.  If a non-empty \'TextList\' is present in this 
                    section this key is ignored.  Attempting to add an 
                    existing text address causes a cfg warning.  Adding and 
                    removing the same text address for a target produces 
                    unspecified results. 
                    
                    May not be empty. 
                    
                    No default.\n|,
                    
TextListRemove      => qq|List of text receipients to remove from the global 
                    textlist, if present and not empty. The resulting list is 
                    used for this target if no \'TextList\' key is  present in 
                    this section.  If a non-empty \'TextList\' is present in 
                    this section this key is ignored.  Attempting to remove a 
                    non-existent text address causes a cfg warning.  Removing
                    and adding the same text address for a target produces 
                    unspecified results. 
                                     
                    May not be empty.  
                    
                    No default. \n|, 
                    
AlertDirection      => qq|Defines which target status change direction causes a 
                    failure alert, up or down.  Setting this key to UP (i.e. 
                    alerting on up) disables the use of ReportGroups for this 
                    target.  See the KnowledgeBase option (-kb) for additional 
                    information and cautions on using this cfg key.  
                    
                    UP or DOWN, case insensitive. 
                    
                    May not be empty.
                    
                    Overrides the global default.\n|,
                    
AlertMethod         => qq|A comma-separated list of one or more methods to be used 
                    for sending alerts for this target: 
                    - Email, (allows text alerts directly from this program)  
                    - Syslog (no text alerts sent directly from this program)  
                    Enter the methods desired as a comma-separated list on the 
                    same line as the key.  Use the empty value to stop the use of
                    any alerting for this target.  
                     
                    Email and/or syslog, case insensitive.  
                    
                    May be empty.
                    
                    Overrides any global default setting.\n|,

AlertSlowDown       => qq|Gradually reduce the frequency of all types of alerts 
                    while this target is continuously down.  Only the alerting
                    rate is affected.  All other functions continue at normal 
                    rates.  If AlertDirection is UP (selected Appchkr types
                    only) AlertSlowDown applies to alerts issued for the 
                    \'up\' state instead, not \'down\'.

                    1 (enable) or 0 only. 

                    May not be empty.
                    
                    Overrides the global default setting.\n|,
                    
Criticality         => qq|Sets the logging, alerting, and reporting level for this 
                    target: 
                    HIGH = logging, reporting and alerting by email and text,
                    MEDIUM = logging, reporting and alerting by email only, 
                    LOW = logging and reporting only (no alerts).                     
                    Targets are grouped in reports in descending order of 
                    criticality. 
                    
                    Allowed values are High, Medium, Low. 
                    
                    Case insensitive.  
                    
                    May not be empty. 
                    
                    Overrides the global default setting.\n|,
                    
ConnectTimeout      => qq|Timeout to be used when attempting to connect to this 
                    target (i.e. when checking it.)   Cannot be set at the 
                    global level.  Use only for individual problem targets 
                    exhibiting excesively slow connect times that causes them 
                    to register as down at random times.  Normally not needed.  
                    May slow down the rate of polling (loop time) noticeably 
                    if set on many targets. 
                    
                    CAUTION: Sudden connect failures and then success on the 
                    following poll of a target previously functioning normally 
                    can be indicative of a transient (temporary) network or 
                    host system slowdown, or an intermittent condition needing 
                    attention.  It is advisable to NOT use this parameter to 
                    mask such a condition--correct the underlying cause 
                    instead.  
                    
                    Integer seconds between 1 and $ogD
                    
                    May not be empty. |,                       
                    
ConnectTimeout_d    => hlB,          

NoUpTime            => qq|Enables uptime reporting for this target when uptime 
                    reporting has been disabled globally in the [$koD] 
                    section.  Has no effect if reporting has not been disabled
                    globally.  This feature allows the uptime report to
                    contain only those targets that need it in a large system, 
                    keeping it small.  Omit this key if uptime reporting is 
                    always desired for this target.  Checking and recording of 
                    uptime continues while uptime reporting is disabled.  Only 
                    its reporting is affected by this key. 

                    0 enables uptime reporting on this target if off globally.
                    
                    May not be empty.             
                    
                    Overrides the global default.\n|,

ReportGroups        =>qq|A comma-separated list of group names that group targets 
                    together for reporting purposes.  Group names are created 
                    by the user and are distinct from target section names.  
                                      
                    A report group name defines targets which are related in 
                    some way important to the user.  Put the name in the 
                    \'ReportGroups\' key of each target chosen to be in the 
                    group.  A report group name must appear in the 
                    \'ReportGroups\' entry of at least two different targets
                    to create a report group.  Total uptime and status across 
                    all members of the group are reported in the corresponding 
                    group reports:  If any member of the group is down the 
                    group is reported as down.  
                    
                    A target with AlertDirection = UP (i.e. set for AlertOnUP) may
                    not have any ReportGroups.  Any defined are ignored.

                    Cfg error alerts are sent for: 
                        - A duplicated name in a target\'s ReportGroups list  
                        - A \'ReportGroups\' name given in only one target
                        - More than four \'ReportGroups\' names for one 
                          target.  
                        - An invalid \'ReportGroups\' group name. 
                        - One or more ReportGroups defined with AlertOnUp set.
                    
                    There is no limit to the total number of ReportGroups 
                    defined in a cfg file but no more than four may be 
                    assigned to any one target.  Any beyond that are 
                    discarded.   

                    See the knowledge base (-kb option) topic REPORTGROUPS 
                    for more on understanding and using report groups. 
                    
                    Each name must be $fpD characters maximum.
                    
                    Group Names may use only alphanumeric characters and _ .
                    
                    Zero (0, 00, 000, etc) is not an allowed name. 
                    
                    Up to four comma-separated names may be listed per target. 
                     
                    Order of the group names is irrelevant.
                    
                    Group names are case sensitive.   
                    
                    May not be empty. 
                    
                    No default. \n|, 
                    
UseIP               =>qq|Specifies the use of a numerical IP address rather than  
                    a hostname (FQDN) for checking this target.  This program 
                    converts, if possible, a target hostname to a numerical IP 
                    address if a hostname is entered in the \'host\' 
                    value.  This conversion occurs once, before checking 
                    begins, each time the cfg file is read.  If the conversion
                    attempt fails the hostname is used for checking as is, 
                    i.e. as a hostname, not an IP address.  If connect fails 
                    when this setting is in effect connect is also retried 
                    once with the hostname, in case the IP address has changed 
                    since the last read of the cfg file.  If this latter 
                    connect succeeds a warning alert is issued and the new
                    IP address used thereafter.  Otherwise an error alert
                    is issued.   
                    
                    Using IP addressses may be very slightly faster and is 
                    most suited to networks with static address assignments, or 
                    very long and stable DHCP leases or reserved addresses.  
                    However, if checking the DNS lookup process is a desired 
                    part of the overall checking process leave this parameter 
                    set to 0 and use a hostname in the \'Host\' value.  
                    This setting is also useful for detecting DHCP address 
                    changes deliberatly.  Refer to the knowledge base 
                    (-kb option) for more information.  

                    1 to use IP addresses, 0 not to. 
                                        
                    May not be empty.
                    
                    Overrides the global default.\n|,
     
    },
); 
use warnings;  




sub szD { 
    return keys %{$xjD{$_[0]}} if $_[0] ;
    keys %xjD ;
}


my %jjD = (
    appchkr     => {
        Setup       => {
            
        	AdminMailList        => '',
        	AlertCutOff          => '',
        	AlertCutOff_d        => '',
        	AlertDirection       => '',
        	AlertDirection_d     => '',
        	AlertMethod          => '',
        	AlertMethod_d        => '',
        	AlertSlowDown        => '',
        	AlertSlowDown_d      => '',
        	Criticality          => '',
        	Criticality_d        => '',
        	DiscoverySlowDown    => '',
        	DiscoverySlowDown_d  => '',
        	DSDOnlyOnFail        => '',
        	DSDOnlyOnFail_d      => '',
        	Frequency            => '',
        	Frequency_d          => '',
        	HeartbeatPeriod      => '',
        	HeartbeatPeriod_d    => '',
        	InterstepDelay       => '',
        	InterstepDelay_d     => '',
        	Interval             => '',
        	Interval_d           => '',
        	LogFilePath          => '',
        	LogFilePath_d        => '',
        	MailFrom             => '',
        	MailFromPswd         => '',
        	MailList             => '',
        	MailServer           => '',
        	MailServerPorts      => '',
        	MailServerPorts_d    => '',
        	MaxLifeTime          => '',
        	MaxLifeTime_d        => '',
        	MaxLogAge            => '',
        	MaxLogAge_d          => '',
        	MaxLogSize           => '',
        	MaxLogSize_d         => '',
        	MaxLoops             => '',
        	MaxLoops_d           => '',
        	MinLoopTime          => '',
        	MinLoopTime_d        => '',
        	Port                 => '',
        	Protocol             => '',
        	Protocol_d           => '',
        	StaticConfig         => '',
        	StaticConfig_d       => '',
        	SysLogFacility       => '',
        	SysLogFacility_d     => '',
        	SysLogHost           => '',
        	SysLogMethod         => '',
        	SysLogMethod_d       => '',
        	SysLogPort           => '',
        	SysLogPort_d         => '',
        	TextList             => '',
        	UseIP                => '',
        	UseIP_d              => 1,
        	WatchdogPort         => '',
        },                         
        Reports     => {         
        	GroupStatusOn        => '',
        	GroupStatusOn_d      => '',
        	GroupUpTimeOn        => '',
        	GroupUpTimeOn_d      => '',
        	NoUpTime             => '',
        	NoUpTime_d           => '',
        	StatusFilesPath      => '',
        	StatusFilesPath_d    => '',
        	StatusOn             => '',
        	StatusOn_d           => '',
        	StatusUpdate         => '',
        	StatusUpdate_d       => '',
        	UpTimeFilesAge       => '',
        	UpTimeFilesAge_d     => '',
        	UpTimeFilesPath      => '',
        	UpTimeFilesPath_d    => '',
        	UpTimeOn             => '',
        	UpTimeOn_d           => '',
        	ReportPeriod         => '',
        	ReportPeriod_d       => '',
        	UpTimeUpdate         => '',
        	UpTimeUpdate_d       => '',
        },                       
        Targets    => {          
            " REMINDERS: ",'',       
        	AlertDirection       => '',
        	AlertMethod          => '',
        	AlertSlowDown        => '',
        	ConnectTimeout       => '',
        	ConnectTimeout_d     => '',
        	Criticality          => '',
        	Frequency            => '',
        	Host                 => '',
        	HostRange            => '',
        	Interval             => '',
        	MailList             => '',
        	MailListAdd          => '',
        	MailListRemove       => '',
        	NoUpTime             => '',
        	Port                 => '',
        	Protocol             => '',
        	ReportGroups         => '',
        	TextList             => '',
        	TextListAdd          => '',
        	TextListRemove       => '',
        	UseIP                => '',
        },
       },
    dbchkr      => {
        Setup       => {
        	AlertSlowDown        => '',
        	AlertSlowDown_d      => '',
        	Criticality          => '',
        	Criticality_d        => '',
        	HeartbeatPeriod      => '',
        	HeartbeatPeriod_d    => '',
        	InterstepDelay       => '',
        	InterstepDelay_d     => '',
        	Interval             => '',
        	Interval_d           => '',
        	LogFilePath          => '',
        	LogFilePath_d        => '',
        	MailFrom             => '',
        	MailFromPswd         => '',
        	MailList             => '',
        	MailServer           => '',
        	MailServerPorts      => '',
        	MailServerPorts_d    => '',
        	MaxLifeTime          => '',
        	MaxLifeTime_d        => '',
        	MaxLogAge            => '',
        	MaxLogAge_d          => '',
        	MaxLogSize           => '',
        	MaxLogSize_d         => '',
        	Port                 => '',
        	Protocol             => '',
        	Protocol_d           => '',
        	StaticConfig         => '',
        	StaticConfig_d       => '',
        	TextList             => '',
        },                         
        Reports     => {         
        	StatusFilesPath      => '',
        	StatusFilesPath_d    => '',
        	StatusOn             => '',
        	StatusOn_d           => '',
        	UpTimeFilesAge       => '',
        	UpTimeFilesAge_d     => '',
        	UpTimeFilesPath      => '',
        	UpTimeFilesPath_d    => '',
        	UpTimeOn             => '',
        	UpTimeOn_d           => '',
        	ReportPeriod         => '',
        	ReportPeriod_d       => '',
        },                       
        Targets    => {          
            " REMINDERS: ",'',       
        	AlertSlowDown        => '',
        	Criticality          => '',
        	Host                 => '',
        	Interval             => '',
        	MailList             => '',
        	Port                 => '',
        	Protocol             => '',
         	ReportGroups         => '',
        	TextList             => '',
        },
       },
    facilitychkr    => {
        Setup       => {
        	AlertSlowDown        => '',
        	AlertSlowDown_d      => '',
        	Criticality          => '',
        	Criticality_d        => '',
        	HeartbeatPeriod      => '',
        	HeartbeatPeriod_d    => '',
        	InterstepDelay       => '',
        	InterstepDelay_d     => '',
        	Interval             => '',
        	Interval_d           => '',
        	LogFilePath          => '',
        	LogFilePath_d        => '',
        	MailFrom             => '',
        	MailFromPswd         => '',
        	MailList             => '',
        	MailServer           => '',
        	MailServerPorts      => '',
        	MailServerPorts_d    => '',
        	MaxLifeTime          => '',
        	MaxLifeTime_d        => '',
        	MaxLogAge            => '',
        	MaxLogAge_d          => '',
        	MaxLogSize           => '',
        	MaxLogSize_d         => '',
        	Port                 => '',
        	Protocol             => '',
        	Protocol_d           => '',
        	StaticConfig         => '',
        	StaticConfig_d       => '',
        	TextList             => '',
        },                         
        Reports     => {         
        	StatusFilesPath      => '',
        	StatusFilesPath_d    => '',
        	StatusOn             => '',
        	StatusOn_d           => '',
        	UpTimeFilesAge       => '',
        	UpTimeFilesAge_d     => '',
        	UpTimeFilesPath      => '',
        	UpTimeFilesPath_d    => '',
        	UpTimeOn             => '',
        	UpTimeOn_d           => '',
        	ReportPeriod         => '',
        	ReportPeriod_d       => '',
        },                       
        Targets    => {          
            " REMINDERS: ",'',       
        	AlertSlowDown        => '',
        	Criticality          => '',
        	Host                 => '',
        	Interval             => '',
        	MailList             => '',
        	Port                 => '',
        	Protocol             => '',
        	TextList             => '',
        },
       },
    networkchkr     => {
        Setup       => {
        	AdminMailList        => '',
        	AlertCutOff          => '',
        	AlertCutOff_d        => '',
        	AlertMethod          => '',
        	AlertMethod_d        => '',
        	AlertSlowDown        => '',
        	AlertSlowDown_d      => '',
        	Criticality          => '',
        	Criticality_d        => '',
        	DiscoverySlowDown    => '',
        	DiscoverySlowDown_d  => '',
        	DSDOnlyOnFail        => '',
        	DSDOnlyOnFail_d      => '',
        	HeartbeatPeriod      => '',
        	HeartbeatPeriod_d    => '',
        	InterstepDelay       => '',
        	InterstepDelay_d     => '',
        	Interval             => '',
        	Interval_d           => '',
        	LogFilePath          => '',
        	LogFilePath_d        => '',
        	MailFrom             => '',
        	MailFromPswd         => '',
        	MailList             => '',
        	MailServer           => '',
        	MailServerPorts      => '',
        	MailServerPorts_d    => '',
        	MaxLifeTime          => '',
        	MaxLifeTime_d        => '',
        	MaxLogAge            => '',
        	MaxLogAge_d          => '',
        	MaxLogSize           => '',
        	MaxLogSize_d         => '',
        	Port                 => '',
        	Protocol             => '',
        	Protocol_d           => '',
        	StaticConfig         => '',
        	StaticConfig_d       => '',
        	SysLogFacility       => '',
        	SysLogFacility_d     => '',
        	SysLogHost           => '',
        	SysLogMethod         => '',
        	SysLogMethod_d       => '',
        	SysLogPort           => '',
        	SysLogPort_d         => '',
        	TextList             => '',
        	UseIP                => '',
        	UseIP_d              => 1,
        	WatchdogPort         => '',
        },                         
        Reports     => {         
        	GroupStatusOn        => '',
        	GroupStatusOn_d      => '',
        	GroupUpTimeOn        => '',
        	GroupUpTimeOn_d      => '',
        	NoUpTime             => '',
        	NoUpTime_d           => '',
        	StatusFilesPath      => '',
        	StatusFilesPath_d    => '',
        	StatusOn             => '',
        	StatusOn_d           => '',
        	StatusUpdate         => '',
        	StatusUpdate_d       => '',
        	UpTimeFilesAge       => '',
        	UpTimeFilesAge_d     => '',
        	UpTimeFilesPath      => '',
        	UpTimeFilesPath_d    => '',
        	UpTimeOn             => '',
        	UpTimeOn_d           => '',
        	ReportPeriod         => '',
        	ReportPeriod_d       => '',
        	UpTimeUpdate         => '',
        	UpTimeUpdate_d       => '',
        },                       
        Targets    => {          
            " REMINDERS: ",'',       
        	AlertMethod          => '',
        	AlertSlowDown        => '',
        	ConnectTimeout       => '',
        	ConnectTimeout_d     => '',
        	Criticality          => '',
        	Host                 => '',
        	HostRange            => '',
        	Interval             => '',
        	MailList             => '',
        	MailListAdd          => '',
        	MailListRemove       => '',
        	NoUpTime             => '',
        	Port                 => '',
        	Protocol             => '',
        	ReportGroups         => '',
        	TextList             => '',
        	TextListAdd          => '',
        	TextListRemove       => '',
        	UseIP                => '',
        },
       },
    securitychkr    => {
        Setup       => {
        	AlertDirection       => '',
        	AlertDirection_d     => '',
        	AlertSlowDown        => '',
        	AlertSlowDown_d      => '',
        	Criticality          => '',
        	Criticality_d        => '',
        	HeartbeatPeriod      => '',
        	HeartbeatPeriod_d    => '',
        	InterstepDelay       => '',
        	InterstepDelay_d     => '',
        	Interval             => '',
        	Interval_d           => '',
        	LogFilePath          => '',
        	LogFilePath_d        => '',
        	MailFrom             => '',
        	MailFromPswd         => '',
        	MailList             => '',
        	MailServer           => '',
        	MailServerPorts      => '',
        	MailServerPorts_d    => '',
        	MaxLifeTime          => '',
        	MaxLifeTime_d        => '',
        	MaxLogAge            => '',
        	MaxLogAge_d          => '',
        	MaxLogSize           => '',
        	MaxLogSize_d         => '',
        	Port                 => '',
        	Protocol             => '',
        	Protocol_d           => '',
        	StaticConfig         => '',
        	StaticConfig_d       => '',
        	TextList             => '',
        	WatchdogPort         => '',
        },                         
        Reports     => {         
        	StatusFilesPath      => '',
        	StatusFilesPath_d    => '',
        	StatusOn             => '',
        	StatusOn_d           => '',
        	UpTimeFilesAge       => '',
        	UpTimeFilesAge_d     => '',
        	UpTimeFilesPath      => '',
        	UpTimeFilesPath_d    => '',
        	UpTimeOn             => '',
        	UpTimeOn_d           => '',
        	ReportPeriod         => '',
        	ReportPeriod_d       => '',
        },                       
        Targets    => {          
            " REMINDERS: ",'',       
        	AlertDirection       => '',
        	AlertSlowDown        => '',
        	Criticality          => '',
        	Host                 => '',
        	HostRange            => '',
        	Interval             => '',
        	MailList             => '',
        	Port                 => '',
        	Protocol             => '',
        	ReportGroups         => '',
        	TextList             => '',
        },
       },
    serverchkr      => {
        Setup       => {
        	AdminMailList        => '',
        	AlertCutOff          => '',
        	AlertCutOff_d        => '',
        	AlertMethod          => '',
        	AlertMethod_d        => '',
        	AlertSlowDown        => '',
        	AlertSlowDown_d      => '',
        	Criticality          => '',
        	Criticality_d        => '',
        	DiscoverySlowDown    => '',
        	DiscoverySlowDown_d  => '',
        	DSDOnlyOnFail        => '',
        	DSDOnlyOnFail_d      => '',
        	HeartbeatPeriod      => '',
        	HeartbeatPeriod_d    => '',
        	InterstepDelay       => '',
        	InterstepDelay_d     => '',
        	Interval             => '',
        	Interval_d           => '',
        	LogFilePath          => '',
        	LogFilePath_d        => '',
        	MailFrom             => '',
        	MailFromPswd         => '',
        	MailList             => '',
        	MailServer           => '',
        	MailServerPorts      => '',
        	MailServerPorts_d    => '',
        	MaxLifeTime          => '',
        	MaxLifeTime_d        => '',
        	MaxLogAge            => '',
        	MaxLogAge_d          => '',
        	MaxLogSize           => '',
        	MaxLogSize_d         => '',
        	Port                 => '',
        	Protocol             => '',
        	Protocol_d           => '',
        	StaticConfig         => '',
        	StaticConfig_d       => '',
        	SysLogFacility       => '',
        	SysLogFacility_d     => '',
        	SysLogHost           => '',
        	SysLogMethod         => '',
        	SysLogMethod_d       => '',
        	SysLogPort           => '',
        	SysLogPort_d         => '',
        	TextList             => '',
        	UseIP                => '',
        	UseIP_d              => 1,
        	WatchdogPort         => '',
        },                         
        Reports     => {         
        	GroupStatusOn        => '',
        	GroupStatusOn_d      => '',
        	GroupUpTimeOn        => '',
        	GroupUpTimeOn_d      => '',
        	NoUpTime             => '',
        	NoUpTime_d           => '',
        	StatusFilesPath      => '',
        	StatusFilesPath_d    => '',
        	StatusOn             => '',
        	StatusOn_d           => '',
        	StatusUpdate         => '',
        	StatusUpdate_d       => '',
        	UpTimeFilesAge       => '',
        	UpTimeFilesAge_d     => '',
        	UpTimeFilesPath      => '',
        	UpTimeFilesPath_d    => '',
        	UpTimeOn             => '',
        	UpTimeOn_d           => '',
        	ReportPeriod         => '',
        	ReportPeriod_d       => '',
        	UpTimeUpdate         => '',
        	UpTimeUpdate_d       => '',
        },                       
        Targets    => {          
            " REMINDERS: ",'',       
        	AlertMethod          => '',
        	AlertSlowDown        => '',
        	ConnectTimeout       => '',
        	ConnectTimeout_d     => '',
        	Criticality          => '',
        	Host                 => '',
        	HostRange            => '',
        	Interval             => '',
        	MailList             => '',
        	MailListAdd          => '',
        	MailListRemove       => '',
        	NoUpTime             => '',
        	Port                 => '',
        	Protocol             => '',
        	ReportGroups         => '',
        	TextList             => '',
        	TextListAdd          => '',
        	TextListRemove       => '',
        	UseIP                => '',
        },
       },
    sohochkr        => {
        Setup       => {
        	AlertSlowDown        => '',
        	AlertSlowDown_d      => '',
        	Criticality          => '',
        	Criticality_d        => '',
        	HeartbeatPeriod      => '',
        	HeartbeatPeriod_d    => '',
        	InterstepDelay       => '',
        	InterstepDelay_d     => '',
        	Interval             => '',
        	Interval_d           => '',
        	LogFilePath          => '',
        	LogFilePath_d        => '',
        	MailFrom             => '',
        	MailFromPswd         => '',
        	MailList             => '',
        	MailServer           => '',
        	MailServerPorts      => '',
        	MailServerPorts_d    => '',
        	MaxLifeTime          => '',
        	MaxLifeTime_d        => '',
        	MaxLogAge            => '',
        	MaxLogAge_d          => '',
        	MaxLogSize           => '',
        	MaxLogSize_d         => '',
        	Port                 => '',
        	Protocol             => '',
        	Protocol_d           => '',
        	StaticConfig         => '',
        	StaticConfig_d       => '',
        	TextList             => '',
        },                         
        Reports     => {         
        	StatusFilesPath      => '',
        	StatusFilesPath_d    => '',
        	StatusOn             => '',
        	StatusOn_d           => '',
        	UpTimeFilesAge       => '',
        	UpTimeFilesAge_d     => '',
        	UpTimeFilesPath      => '',
        	UpTimeFilesPath_d    => '',
        	UpTimeOn             => '',
        	UpTimeOn_d           => '',
        	ReportPeriod         => '',
        	ReportPeriod_d       => '',
        },                       
        Targets    => {          
            " REMINDERS: ",'',       
        	AlertSlowDown        => '',
        	Criticality          => '',
        	Host                 => '',
        	Interval             => '',
        	MailList             => '',
        	Port                 => '',
        	Protocol             => '',
        	TextList             => '',
        },
       },
    testchkr        => {
        Setup       => {
        	AlertSlowDown        => '',
        	AlertSlowDown_d      => '',
        	Criticality          => '',
        	Criticality_d        => '',
        	HeartbeatPeriod      => '',
        	HeartbeatPeriod_d    => '',
        	InterstepDelay       => '',
        	InterstepDelay_d     => '',
        	Interval             => '',
        	Interval_d           => '',
        	LogFilePath          => '',
        	LogFilePath_d        => '',
        	MailFrom             => '',
        	MailFromPswd         => '',
        	MailList             => '',
        	MailServer           => '',
        	MailServerPorts      => '',
        	MailServerPorts_d    => '',
        	MaxLifeTime          => '',
        	MaxLifeTime_d        => '',
        	MaxLogAge            => '',
        	MaxLogAge_d          => '',
        	MaxLogSize           => '',
        	MaxLogSize_d         => '',
        	Port                 => '',
        	Protocol             => '',
        	Protocol_d           => '',
        	StaticConfig         => '',
        	StaticConfig_d       => '',
        	TextList             => '',
        },                         
        Reports     => {         
        	StatusFilesPath      => '',
        	StatusFilesPath_d    => '',
        	StatusOn             => '',
        	StatusOn_d           => '',
        	UpTimeFilesAge       => '',
        	UpTimeFilesAge_d     => '',
        	UpTimeFilesPath      => '',
        	UpTimeFilesPath_d    => '',
        	UpTimeOn             => '',
        	UpTimeOn_d           => '',
        	ReportPeriod         => '',
        	ReportPeriod_d       => '',
        },                       
        Targets    => {          
            " REMINDERS: ",'',       
        	AlertSlowDown        => '',
        	Criticality          => '',
        	Host                 => '',
        	Interval             => '',
        	MailList             => '',
        	Port                 => '',
        	Protocol             => '',
        	TextList             => '',
        },
       },
); 


sub pwD { 
    $jjD{$baD}{$_[0]}{$_[1]}  
        or $xjD{$_[0]}{$_[1]}
}
    
    
sub euD {
    return keys %{$jjD{$baD}{$_[0]}} if $_[0] ;
    keys %{$jjD{$baD}} ;
}

{ 
    
    my $fqD = "\n\n_____________________________";
    my $ubD = "_____________________________\n\n";
    my $lxD = ' CONFIGURATION'; 
    
    sub xzD {
        my $njD = shift; 
        
        $njD ||= ''; 
        if    ($njD =~/^s/i) { zfD() } 
        elsif ($njD =~/^r/i) { kwD()}
        elsif ($njD =~/^t/i) { hjD() }
        else  { exD() }
    }

    
    sub exD {    
        xlD() . zfD() . kwD() . hjD(); 
    }
    
    
    sub zfD {    
        my @ghD    = map {my $tmp = /_d$/ ? "\n" : ''; 
                            my $tmp2 = ($jjD{$baD}{$izD}{$_} 
                                          or $xjD{$izD}{$_}   
                                       );
                            $tmp2 =~s/\*|\s//g  if /criticality_d/;  
                           sprintf("%-*s", tsB, $_).$tmp2.$tmp; 
                           }  sort keys %{$jjD{$baD}{$izD}}; 
        $fqD.uc($izD).$lxD.$ubD.join ("\n", @ghD) ;

    }    
    
    
    sub kwD {    
        my @kmD  = map {my $tmp = /_d$/ ? "\n" : '';
                           my $tmp2 = ($jjD{$baD}{$koD}{$_}
                                          or $xjD{$koD}{$_}    
                                      );
                           sprintf("%-*s", tsB, $_).$tmp2.$tmp; 
                          }  sort keys %{$jjD{$baD}{$koD}}; 
        $fqD.uc($koD).$lxD.$ubD.join ("\n", @kmD);
    }    
    
    
    sub hjD {    
        my @uvD = map {my $tmp = /_d$/ ? "\n" : '';
                           my $tmp2 = ($jjD{$baD}{$muD}{$_}
                                          or $xjD{$muD}{$_}  
                                      );
                           sprintf("%-*s", tsB, $_).$tmp2.$tmp; 
                          }  sort keys %{$jjD{$baD}{$muD}}; 
        $fqD.uc($muD).$lxD.$ubD.join ("\n", @uvD);
    }    
} 


sub bzD {
    
qq|
______________________________PROGRAM DESCRIPTION______________________________

This program checks hardware and software systems, collectively called 
targets, that communicate with others over an IP network by checking that 
their network communication capability is working. The results are logged. 
Targets which don\'t respond result in email and text messages if desired. 
Lack of response indicates one or more of several possible faults:
(1) A target (or its host machine) which is down or hung.
(2) Loss of network connectivity by the target.
(3) A target which is overloaded, too busy to respond.
(4) Loss of connectivity between this program\'s host machine and the target.

Each target to be checked must be listening for a connection on one or more IP 
ports and addresses.  The port number may be one specific to an application to 
be checked or may be a general purpose one to check on a host machine itself.  
MSWindows machines, for instance, often listen on port 445 or 139 when they 
are running, and port 22 is commonly listening on Linux machines.  

The checking is controlled by a configuration file that specifies what is to be 
checked, and optionally how often, when and to whom to send failure alerts and 
reports, and so on. Sensible defaults for most parameters allow quick startup 
with minimal manual configuration effort. 

Start the program with the program name followed by the configuration file 
path and name (required) on the command line. A simple configuration file that 
tests its own connection is provided at installation.  Run the program 
initially with this configuration file and customize it to your needs as 
required to get up and running quickly.  

Sample configuration files are included in the \'smp\' directory to illustrate 
configuration for common situations.  Select one or more of these closest to 
your requirements and tailor them to your needs.   Complete configuartion 
documentation is available with the \'-cfg\' commandline option, along with 
briefer slices by using the \'-list\', \'-find x\', and \'-cfg s\' options.

Three criticality levels for targets may be used: HIGH (H), MEDIUM (M), and 
LOW (L) with different levels of behavior for each.  All targets default to 
MEDIUM unless configured othewise.   For instance, if alerting is configured, 
alerts such as 

$fyD [Target A] has failed to respond for 3 minutes ...

are sent for targets of MEDIUM criticality that fail to respond.   "Target A" 
is the name for this target given in the configuration file.  When such 
targets resume responding one alert as 

$oiD [Target A] has responded again ...

is sent promptly. 

HIGH criticality alerts are in the same format but use the prefix

$tnD

and can also be configured to send text (SMS) alerts in addition to email and
syslog alerts.  No alerts are sent for LOW criticality targets.  Their 
checking results are only logged and reported in the status and uptime files.  

By default alerting rates decline over time for targets which are continously 
unresponsive, to avoid email and text message flooding. This setting may be 
turned off.  Only the rate of alerting declines. Checking continues at the 
configured rate and the results show in the status and log files.

In addition, if the number of consecutive target connect failures within one 
loop exceeds $xjD{$izD}{AlertCutOff_d} further alerts are suppressed until the next loop, also to 
avoid email and text flooding when large segments of a network go down.  
Logging and reporting are not affected by this cutoff, only alerting. 

If alerting is not configured review the status file or log to see the status 
of all checked targets.  By default both are located in directories beneath 
the installation directory:

$eiD$l1D$jbD

for the status report and 

$eiD$l1D$o2D

for the log.  They are named like *status.txt and *.log, unless named 
otherwise and located elsewhere by settings in the configuration file. 

The standard versions of this program are for MSWindows and Linux. For a 
version for another operating system such as a flavor of UNIX or MAC OS 
contact Nova Software at sales\@nova-sw.com or (USA) 617-965-1437.

Start and stop the program as described by the \'run\' and \'stop\' options. 
Once started the program runs continuously in the background as a daemon, 
without requiring any direct user connection or window.  Communicate with and
control a running program thru the commandline, or the web interface provided.
The program runs until stopped manually, or can be configured to stop at a 
pre-determined point.

The default mode of operation is to loop through the configured list of targets 
in alphanumeric order by name.  Each target that is eligible for checking on 
that loop is tested.  The default recheck period for each listed target is $xjD{$izD}{Interval_d} 
minutes.  The minimum loop period is $vyD minutes. The actual time of any one 
loop will vary upward from this, depending on the amount of activity and delay 
in that loop.  Configuration parameters allow altering this mode of operation 
in many ways, either globally or per-target.

Checking results are continuously logged into the log file, and shown in the 
periodic status snapshot report for all configured targets.  If not otherwise
configured these files are at the default locations given above. 

By default the configuration file can be updated while the program is running.  
This feature allows, for example, changing the list of those receiving alerts 
to match those who are on duty, or changing the list of targets to be checked 
between the day and night, and so on -- just copy the appropriate file to the 
cfg file location used to start up the program, at the desired points in time.  
This feature may be disabled with a setting in the configuration file, 
requiring instead a restart of the program to reconfigure it. 

Multiple instances of this program may run from a single installation, if 
activated with a subscription, by using different configuration files with 
different filepathnames.  Each configuration file must either specify 
different file paths for all the files written by the program, (logfilepath, 
report paths), or use the default names and locations, which include the cfg 
file name to make them distinct.  

Multiple instances require an activated subscription in the installation.  
The total quantity of targets licensed by the subscription is divided among 
all the running instances each time they start: The total number of targets 
from all the running instances should be no greater than the subscription 
total.  

A program running in free mode, without an activated subscription, can only 
run a single instance. 

A \'watchdog\' port may be configured so that this program itself may be 
monitored by another installation (ideally on another host machine) or some 
other monitoring tool.  This capability insures that a silent failure will be 
unlikely to leave the targets without checking or notification of that fact.  
For the same purpose a \'heartbeat\' alert is sent periodically by default if  
alerting is configured.  The frequency of this alert is configurable.   

By default the program uses IP addresses for checking, automatically 
converting any host name into numeric IP addresses.  This setting may be 
changed at the global or individual target level.  

Software updates are downloaded automatically for subscriptions.  Users 
decide whether to install the update or not, although Nova Software strongly 
encourages everyone to keep up-to-date with the current release for best 
results.  Rollback to the prior version is provided should there be serious
issues with a new release. 

The following features, available on some Appchkr types, are described in more 
detail in the configuration option ( -cfg), and in the knowledge base option 
(-kb).  
(1) Discovery and checking of all active targets within a specified range of 
IP addresses, for a particular port or protocol, and 
(2) Reporting groups to report aggregate results for groups of targets in 
addition to those for individual targets.  
 
Two report files are created by default:
(1) A status file giving the snapshot status of all monitored targets, updated 
    after each loop by default. The latest update of this report may be 
    followed continuously in the user web interface (UWI). 
(2) An uptime file giving the uptime and downtime percentage of each target   
    for a user-selectable period.  This report is also updated every loop by 
    default and may also be followed continuously in the UWI. 
    
If \'ReportGroups\' are configured then status and uptime reports for those 
groups are also printed by default.  

Any of these four reports can be turned off or reconfigured in various ways to 
meet special needs. 
|;

} 


my %teD = (

    afpovertcp          => [548, 'tcp', 'Apple filing protocol, Apple' ],
    bgp                 => [179, 'tcp', 'Border Gateway Protocol, IETF'],
    bootps              => [67, 'tcp', 'Boot Protocol server, IETF'],
    bootpc              => [68, 'tcp', 'Boot Protocol client, IETF'],
    chkr_wd_0           => [5510, 'tcp', 'Chkr Watchdog Listener, Nova Software'],
    chkr_wd_1           => [5511, 'tcp', 'Chkr Watchdog Listener, Nova Software'],
    chkr_wd_2           => [5512, 'tcp', 'Chkr Watchdog Listener, Nova Software'],
    chkr_wd_3           => [5513, 'tcp', 'Chkr Watchdog Listener, Nova Software'],
    chkr_wd_4           => [5514, 'tcp', 'Chkr Watchdog Listener, Nova Software'],
    chkr_wd_5           => [5515, 'tcp', 'Chkr Watchdog Listener, Nova Software'],
    chkr_web_server     => [9999, 'tcp', 'Web server for chkrs\' user web interface, Nova Software'],
    cifs                => [3020, 'tcp', 'Common Internet File System, IETF'],
    db2                 => [523, 'tcp', 'DataBase2, IBM'],
    dhcp_client         => [68, 'tcp', 'Dynamic Host Configuration Protocol client, IETF'],
    dhcp_server         => [67, 'tcp', 'Dynamic Host Configuration Protocol server, IETF'],
    dhcp_client_udp     => [68, 'udp', 'Dynamic Host Configuration Protocol client, IETF'],
    dhcp_server_udp     => [67, 'udp', 'Dynamic Host Configuration Protocol server, IETF'],
    dhcp_failover       => [647, 'tcp', 'Dynamic Host Configuration Protocol server failover, IETF'],
    dhcp_failover2      => [847, 'tcp', 'Dynamic Host Configuration Protocol server failover2, IETF'],
    dns                 => [53, 'tcp', 'Domain Name System, IETF'],
    dns_udp             => [53, 'udp', 'Domain Name System, IETF'],
    ems                 => [9167, 'tcp', 'Enterprise Messaging System (JMS), Tibco'],
    ftp_data            => [20, 'tcp', 'File Transfer Protocol, IETF'],    
    ftp                 => [21, 'tcp', 'File Transfer Protocol, IETF'],
    http                => [80, 'tcp', 'Hypertext Transfer Protocol, WWW Consortium'],
    http_alt            => [8080, 'tcp', 'Hypertext Transfer Protocol alternate, WWW Consortium'],
    https               => [443, 'tcp', 'Hypertext Transfer Protocol secure, WWW Consortium'],
    imap                => [143, 'tcp', 'Interactive Mail Access Protocol, IETF'],
    imaps               => [993, 'tcp', 'Interactive Mail Access Protocol secure, IETF'],
    informix            => [9088, 'tcp', 'Informix Database, IBM'],
    ipp                 => [631, 'tcp', 'Internet Printing Protocol, Apple'],
    jms                 => [5673, 'tcp', 'Java Messaging Server, Oracle' ],
    kerberos            => [88, 'tcp', 'Kerberos Security Method, IETF'],
    ldap                => [389, 'tcp', 'Lightweight Directory Access Protocol, IETF'],
    llmnr               => [5355, 'tcp', 'Link Local Multicast Name Resolution, Microsoft'],
    lpd                 => [515, 'tcp', 'Line Printer Daemon, IETF'],
    mdns                => [5353, 'tcp', 'Multicast DNS, IETF'],
    mysql               => [3306, 'tcp', 'mySQL Database, mySQL Corp.' ],
    nameserver          => [42,'tcp', 'Host Name Server, IETF'],  
    netbios_dgm         => [138, 'udp', 'NetBios Datagram, Microsoft'],
    netbios             => [1111, 'tcp', 'NetBios, Microsoft'],
    nfs                 => [2049, 'tcp', 'Network File System, Sun'],
    nntp                => [119, 'tcp', 'Network News Transfer Protocol, IETF'],
    ntp                 => [123, 'udp', 'Network Time Protocol, IETF'],
    oracle              => [1521, 'tcp', 'Oracle Database, Oracle'],
    oracle_hi           => [1531, 'tcp', 'Oracle Database, Oracle'],
    password_server     => [106, 'tcp', 'Password Server, Apple'],  
    pdlds               => [9100, 'tcp', 'Page Description Language Data Stream, IETF'],
    pop3                => [110, 'tcp', 'Post Office Protocol 3, IETF'],
    spop3               => [995, 'tcp', 'Secure Post Office Protocol 3, IETF'],
    pop3s               => [995, 'tcp', 'Post Office Protocol 3 secure, IETF'],    
    postgressql         => [5432, 'tcp', 'Postgressql database, Postgres Collaboration'],
    radius              => [1812, 'tcp', 'Remote Authentication Dial-in User Service, IETF'],
    rpc_tcp             => [111, 'tcp', 'Remote Procedure Call, SUN Corp.'],
    rtsp                => [554, 'tcp', 'Real Time Streaming Protocol (QuickTime), Apple'],
    scp                 => [22, 'tcp', 'Secure Copy Protocol, IETF '],
    sftp                => [115, 'tcp', 'Secure File Transfer Protocol, IETF'],
    smb                 => [139, 'tcp', 'Server Message Block, Microsoft'],
    smb_server          => [445, 'tcp', 'Server Message Block Server, Microsoft'],
    smtp                => [25, 'tcp', 'Simple Mail Transfer Protocol, IETF'],
    server_mail_in      => [25, 'tcp', 'Simple Mail Transfer Protocol, IETF'],
    smtp_s              => [465, 'tcp', 'Simple Mail Transfer Protocol secure (obs), IETF'],  
    snmp                => [161, 'tcp', 'Simple Network Management Protocol, IETF'],
    snmp_trap           => [162, 'udp', 'Simple Network Management Protocol - trap, IETF'],
    soap                => [7627, 'tcp', 'Simple Object Access Protocol, Microsoft'],
    soap_http           => [7627, 'tcp', 'Simple Object Access Protocol, Microsoft'],
    sql_server          => [1433, 'tcp', 'SQL Server Database, Microsoft'],
    sql_server_name     => [1434, 'udp', 'SQL Server Database name service, Microsoft'],
    ssh                 => [22, 'tcp', 'Secure Shell, IETF'],
    smtp_submission     => [587, 'tcp', 'Simple Mail Transfer Protocol Submission, IETF'],
    client_mail_in      => [587, 'tcp', 'Simple Mail Transfer Protocol Submission, IETF'],
    sybase              => [1498, 'tcp', 'Sybase Database, Sybase Corp.'],
    syslog              => [514, 'udp', 'Sytem log protocol, IETF'],
    syslog_tcp          => [1468, 'tcp', 'System log protocol over tcp, IETF'],
    syslog_tls          => [6514, 'tcp', 'System log protocol secure, IETF'],
    tftp                => [59, 'tcp', 'Trivial File Transfer Protocol, IETF'],
    tcp                 => [22, 'tcp', 'Transmission Control Protocol, IETF' ],
    tacacs              => [49, 'tcp', 'Terminal Acess Controller Access Control System, Cisco'],
    telnet              => [23, 'tcp', 'TELNET, IETF'],
    udp                 => [22, 'udp', 'User Datagram Protocol, IETF'],
    wins                => [137, 'udp', 'Windows Internet Name Service, Microsoft'],
    wsdl_event          => [4879,'tcp', 'Web Services Description Language - event, Microsoft'],
);



sub zzD {$teD{$_[0]} }
sub xfD { keys %teD }


sub dpD {

    my @ijD = map {sprintf("%-*s", 18, $_)."= "
                        .sprintf("%-*s", 8, $teD{$_}->[0])
                        .sprintf("%-*s", 6, $teD{$_}->[1])
                        .sprintf("%-*s", 60, $teD{$_}->[2])
                        } sort keys %teD;
qq|
___________________________________PROTOCOLS___________________________________

Common internet protocol ports used by typical targets are pre-configured by 
name in the program for your convenience. These protocols are listed here in 
both name and port number order. The associated name, port number, base ip 
method (tcp or udp) and description are given.

Using one of these names for the value of the \'protocol\' key will 
automatically use the corresponding port number given here.  It need not be 
entered separately.  Any other internet protocol based on tcp or udp can be 
accomodated by explicitly configuring its port number, and its IP base method 
as the protocol, normally tcp.  See the examples in the sample configuration 
files provided with the program.

CAUTION: The protocol name given below, as used in this program, in some cases
may not match that given in the defining list of registered services and their 
assigned ports at  

http://www.iana.org/assignments/service-names-port-numbers/service-names-port-numbers.xhtml

Always use the version of the name given below (case insensitive) to configure 
this program.  This list may also include some protocols in common use, but 
not registered with IANA.  The original registrant, if pertinent, or 
the party currently responsible for the protocol is also given where known.   

Note that some port numbers appear with two or more names. 

In many cases, such as FTP and SSH, a single port number is registered for 
both the TCP and UDP methods.  In most such cases only the TCP method is 
listed here since the system used here works primarily with the TCP method.  
The UDP version can be used by simply listing the port number on one line and 
the protocol as udp on another.  It must be recognized, however, that 
confirming successful receipt of a UDP request cannot currently be done within 
$baD, at the sending end, for UDP protocols.   Receipt must be confirmed 
independently at the receiving end or by some reply technique provided outside 
of this program. 

If a service is primarily used via UDP it is listed that way here, even if a 
TCP registration also exists.  The TCP version can be invoked by setting the
port number to that value, and the protocol to tcp. 

|
. "Ordered by name:\n\n"
. join("\n",@ijD) ."\n\n"
. "Ordered by port number:\n\n"
. join("\n", sort{substr($a,20,8) <=> substr($b,20,8)} @ijD) ."\n\n";

}


sub q3D {
    
q|    
________________________________TEXTING PORTALS________________________________

Text (sms) messages may be initiated by email in the USA via special addresses 
maintained by the phone companies.  These portals expect the phone number (as 
10 digits only, no spaces or other separator characters, e.g. 1234567890 ) 
before the @ sign that begins the portal address, thus:  

    Alltel              phonenumber@message.alltel.com
    AT&T Wireless       phonenumber@txt.att.net
    Boost Mobile        phonenumber@myboostmobile.com
    Cricket             phonenumber@sms.mycricket.com
    Metro PCS           phonenumber@mymetropcs.com
    Nextel              phonenumber@messaging.nextel.com
    Ptel                phonenumber@ptel.com
    Qwest               phonenumber@qwestmp.com
    Sprint              phonenumber@pm.sprint.com
    Sprint PCS          phonenumber@messaging.sprintpcs.com
    Sprint PCS Short    phonenumber@sprintpcs.com
    Suncom              pnonenumber@tms.suncom.com
    T-Mobile            phonenumber@tmomail.net
    Tracfone            phonenumber@mmst5.tracfone.com
    U.S. Cellular       phonenumber@email.uscc.net
    Verizon             phonenumber@vtext.com
    Virgin Mobile       phonenumber@vmobl.com

Enter such email addresses in the various text lists in the cfg file to send, 
add, or remove text messages to those phones. 

Comparable capabilities may exist in other countries.  Check with your phone
company.  
    
|; 

}


{ 

    my @u1D = (
qq|
An unidentified error has occurred.  All enciphered credentials and 
passwords may need to be re-enciphered and any subscription reactivated.
|,

qq| 
The security subsystem for 'mailfrompassword' for cfg files was inadvertently 
reinitialized on or before the date shown above.  All previously-enciphered 
passwords have been lost due to an unidentified cause. 

Please reencipher these passwords using the -e commanline option and reenter 
the enciphered values into your cfg files. 

Run the -delsec commandline option to prevent seeing this message again.
|,   
qq| 
The security subsystem for web interface credentials was inadvertently 
reinitialized on or before the date shown above.  All previously-entered 
credentials have been lost due to an unidentified cause. 

Please recreate those credentials using the -auth commandline option. 

Default web credentials of $hbD have been provided until others 
can be recreated.  The first such set created will automatically disable the 
default credentials. 
|,
qq|
The activation of this subscription failed for an unknown reason. 
Please activate again with your subscription ID and passphrase using the
-activate commanline option.
|
);    


    sub nrD {
        my $yxD = shift;
        $yxD = 0 unless defined $yxD;
        my $fsD = 
qq|
************  ALERT   ALERT  ALERT  ALERT  ALERT  ALERT  ALERT  *********** 
From $baD on $ksD by Nova Software:
|.
$u1D[$yxD].
qq|
We apologize for the inconvenience.  

***************************************************************************
|;
  } 
} 


sub gjD {
    my $hdD = shift; 
    $hdD 
    ? "Use the browser's find/search funtion to find the help on a particular topic.\n"
    : ''; 
}


sub feD {
qq |    
- This web interface requires a username and password: $hbD  
  are the default credentials provided for startup until others are entered.  
- Use the commandline -auth option to enter a new username and password as 
  soon as possible.  The first such credentials entered replace the default 
  set to maintain security.  
- Additional credentials may be entered at any time at the commandline with 
  the -auth option.   
- Credentials entered should be unique to this system, i.e. not shared with 
  any other applications, for maximum security.  Generate a secure, easily
  pronounced and remembered password at 
  
  http://multicians.org/thvv/gpw-js.html
|;     
}


sub yeD {  
qq|
Create a web interface user account:

    - Username & password must each be at least 8 
      characters long, with 5 unique. 
    - Username + password must be fewer than 
      $quD characters.
    - Neither may not contain any spaces nor 
      colons, ':'.  
    - Password may not contain the username.  

Please keep these credentials unique to this 
application for maximum security.

|;    
}


sub qnD {
qq|    
- The web server that provides the User Web Interface (UWI) for controlling 
  this program is normally started when the software is installed. It runs 
  continuously as a server while that machine is running so that the program
  can be controlled remotely via the UWI at any time.  To restart the server:  
    
  cd $eiD
    
  and then type at the command prompt:
    
  startuwi  
    
  To stop it type 
    
  stopuwi     
    
  See the Knowledge Base for information about using the optional port
  number when starting this UWI server.  

  These commands can also be run by clicking on them in File Explorer
  (linux) or on the corresponding \'cmd\' file in Windows Explorer. 
  
|;
}


sub vfD {
qq |    
________________________________ HELP FILE ____________________________________

- The recommended browsers for use with the web interface are Firefox version 
  37 or later, Chrome version 51 or later or Safari version 601 or later.  
  Internet Explorer version 11 or later or the Edge browser on MSWin10 may 
  also be used but one of the first three is preferred and will give the 
  most satifactory results.   Versions of any of these browsers prior to 
  those given, as well as any others not mentioned, are not tested nor 
  supported and may, or may not, give satisfactory results. 

- Note that Microsoft browser touchscreen functionality as of this release is 
  still limited.  The mouse must still be used for some functions on MS 
  browsers of this vintage or earlier, whereas the three browsers 
  recommended above provide full touchscreen functionality.

- When using only the web interface to operate the program prepare a cfg file
  on a remote machine and upload it to the program\'s host machine in order 
  to use it.  The upload capability is provided within the 
  \'Configure...\\File...\' menu item.  Copying and modifying a sample cfg 
  file or one of those given in the information web pages makes this process 
  quick and easy.  The \'.cfg\' suffix is automatically put on any uploaded 
  file so that the program can find it when it\'s time to run it.  Only files 
  with that suffix can be run via this web interface. 
  
- The cfg file upload process automatically overwrites any cfg file of the 
  same name in the program\'s cfg directory.  This makes the normal method of
  operating the program thru this web interface quick and easy:  Prepare and
  save a cfg file on any PC or tablet.  Upload it to the program via this web 
  interface and start it here.  Make any subsequent changes by editing the 
  original on the original system or a copy of it on another system.   
  Uploading it thru a browser from any system changes the running program 
  dynamically.  This process works whether the program is also running on the 
  same system or remotely and provides a completly mobile means of operation
  in the latter case. 

- This web interface can be used to stop an instance that was started from the 
  commandline and vice versa.  A running instance can be started by either 
  method and stopped by the other.  

- Report and log files viewed using the web interface update automatically 
  approximately every minute so as to always show the latest data written by 
  a program instance.

- Username + password used to access the web interface must have fewer than 
  $quD characters and must not contain spaces nor colons, ':' . 

- The default port for the web interface is 9999.  Any port number between 
  5001 and 30000 may be used by entering it as the first parameter on the 
  command line that starts the web server.  This range is chosen to minimize
  possible conflict with other services using ports on the host machine and
  to avoid port number ranges restricted by international agreement.  Also
  avoid the port numbers used for the watchdog feature of the program if in 
  use, normally 5510 - 5520.
  
  
- The port number used to start the latest instance of the user web interface
  is saved in the file 
    
  $eiD$l1D$ocD
  
  This file remains even if that instance has been shut down: Its presence 
  does not guarentee that there is a running instance of the web interface.  
  It does serve as a handy reminder if a non-default port is being used and 
  the web interface is to be restarted manually later.   This file is over-
  written each time the web interface starts.

- This web interface, by design, for the security of its host machine, 
  accesses only cfg files within the program\'s own directory structure on 
  that host.  Cfg files in other locations on that machine can only be 
  accessed by using the command line or remote terminal access to run and 
  stop a program instance.

- This web interface is designed primarily for local use within a network 
  behind a firewall.  It has not been fully qualified for external use across 
  the public internet and may or may not give satisfactory results there. 
  
- Be aware that IE11 and MSEdge browers will not connect to hostname urls that
  contain an underscore \'_\' character.  If you run this web interface on 
  a machine whose hostname contains an underscore either connect in these 
  browsers using the numeric IP address of that host, or use one of the 
  recommended browsers noted above, which do connect to such URLs.  This 
  problem can arise since MSWindows permits underscore characters in hostnames.
  Refer to bug ID 905702 and similar posts on Microsoft Connect, and 
  elsewhere, for futher details of this issue. 
  
- All documentation for the command line version of the program follows.  Use 
  the browser\'s find/search function to find any topic of interest therein. 
    
|;
}


sub i8D {
    
    my @ghD    = grep {not /_d$/; } sort keys %{$jjD{$baD}{$izD}};
    my @kmD  = grep {not /_d$/; } sort keys %{$jjD{$baD}{$koD}};
    my @uvD  = grep {not /_d$/; } sort keys %{$jjD{$baD}{$muD}};  
    shift @uvD;  
    

    "\n______________________________LIST OF ALL CFG KEYS______________________________\n"
    ."\n                         --- ".uc($izD)." ---\n"
    .join ("\n", @ghD) 
    ."\n\n\n                         --- ".uc($koD)." ---\n\n"
    .join ("\n", @kmD) 
    ."\n\n\n                         --- ".uc($muD)." ---\n\n"
    .join ("\n", @uvD)
    ."\n";
    
}


sub o4D {
    my $ctD = shift; 
    
    $ctD = defined $ctD ? $ctD : ''; 
  return aqM."Find key string to match is too long. $umD is the maximumum length.\n" 
      unless length $ctD <= $umD; 
  return aqM."Illegal characters -- use upper and lower case Latin (ASCII) letters only.\n" if $ctD =~/\W/;    
    
    my @ghD   = grep { /$ctD/i } sort keys %{$jjD{$baD}{$izD}};
    @ghD      = map { sprintf("%-*s", tsB, $_).$xjD{$izD}{$_} } @ghD;
    my @kmD = grep { /$ctD/i and !/_d$/i } sort keys %{$jjD{$baD}{$koD}};
    @kmD    = map { sprintf("%-*s", tsB, $_).$xjD{$koD}{$_}} @kmD;
    my @uvD = grep { /$ctD/i } sort keys %{$jjD{$baD}{$muD}};
    @uvD    = map {sprintf("%-*s", tsB, $_).$xjD{$muD}{$_} } @uvD;  

    "\n______________________DETAILS OF CFG KEYS MATCHING '$ctD' __________________\n"
    ."\n                         --- ".uc($izD)." ---\n"
    .join ("\n", @ghD) 
    ."\n\n\n                         --- ".uc($koD)." ---\n"
    .join ("\n", @kmD) 
    ."\n\n\n                         --- ".uc($muD)." ---\n"
    .join ("\n", @uvD)
    ."\n";
    
}


our %SLFacilities = (
        kernel    => 0,
        user      => 1,
        mail      => 2,
        daemon    => 3,
        system    => 3,
        auth      => 4,
        syslog    => 5,
        internal  => 5,
        lpr       => 6,
        printer   => 6,
        news      => 7,
        uucp      => 8,
        cron      => 9,
        clock     => 9,
        authpriv  => 10,
        security2 => 10,
        ftp       => 11,
        ntp       => 12,
        audit     => 13,
        alert     => 14,
        clock2    => 15,
        local0    => 16,
        local1    => 17,
        local2    => 18,
        local3    => 19,
        local4    => 20,
        local5    => 21,
        local6    => 22,
        local7    => 23,
);


sub drD {
    my @ztD = map {sprintf("%-*s", 12, $_)."= "
                     .sprintf("%-*s", 8, $SLFacilities{$_})
                     } sort keys %SLFacilities;
qq|

_______________________________SYSLOG FACILITIES_______________________________

The commonly used syslog facility names and their codes are: 

|
. join("\n",@ztD). "\n\n";

}


sub faD {
"\n______________________________________________________________________________\n"
." \n \n \n \n"; 
   
}


sub END{}

1; 
__DATA__
HlspgfQ8BRRcmWTk1mA6Qw
